--
-- Loudmouth
-- Author: FatherJim of Blackhand
-- Email:  praetor@slayernet.org
--

-- TOC:
-- Bindings: 33  Vars: 188  Help: 206  Tabs: 227  UI: 240  Menu: 433
--
--
--

--
-- Set up basic ACE2 library and Fubar data structures and methods.
--

local L = AceLibrary("AceLocale-2.2"):new("Loudmouth")
local md5 = AceLibrary("MDFive-1.0")
local crayon = AceLibrary("Crayon-2.0")
local dewdrop = AceLibrary("Dewdrop-2.0")
local tablet = AceLibrary("Tablet-2.0")

Loudmouth = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceDB-2.0", "AceDebug-2.0", "AceEvent-2.0", "AceModuleCore-2.0", "FuBarPlugin-2.0","AceComm-2.0","Metrognome-2.0")
Loudmouth:RegisterDB("LoudmouthDB","LoudmouthDBPC")

Loudmouth.date="03/28/2007"
Loudmouth.Version=0.808
Loudmouth.build=31171
Loudmouth.version = Loudmouth.build
Loudmouth.updated=""
Loudmouth.name = L["Loudmouth"]

if (UnitName("player") == "Cloudburst" or UnitName("player") == "Druishgal" or UnitName("player") == "Drsmith" or UnitName("player") == "FatherJim" or UnitName("player") == "Skidder" or UnitName("player") == "Swiftfoot" or UnitName("player") == "Straightbore" or UnitName("player") == "Twistlock") then
Loudmouth.dataFrame = ChatFrame3
Loudmouth.debugFrame = ChatFrame4
Loudmouth.ioFrame = ChatFrame5
Loudmouth:SetDebugging(1);
Loudmouth:SetDebugLevel(3);
Loudmouth:CustomLevelDebug(1,1,1,1,Loudmouth.dataFrame,nil,"Configuring Debug output for Author.")
else
Loudmouth:SetDebugLevel(1);
Loudmouth.dataFrame = DEFAULT_CHAT_FRAME
Loudmouth.debugFrame = DEFAULT_CHAT_FRAME
Loudmouth.ioFrame = DEFAULT_CHAT_FRAME
Loudmouth:CustomLevelDebug(1,1,1,1,Loudmouth.dataFrame,nil,"Configuring Debug output for normal user.")
end
Loudmouth:SetCommPrefix("Loudmouth")
Loudmouth:RegisterMemoizations ( {
	"Build",
	"Bus", 
	"Fing", 
	"Loaded",
	"Lock",
	"Loudmouth", 
	"Ping", 
	"Pong",
	"Reset",
	"Upgrade",
	"Version",
	}
)
Loudmouth:CustomLevelDebug(1,0,1,0,Loudmouth.dataFrame,nil,"Debugging Enabled level %d.",Loudmouth:GetDebugLevel());

--
-- Set up Keybindings
--

BINDING_HEADER_LM				= L["Loudmouth"]
BINDING_NAME_LM_SHOW_GUI	= L["Display GUI Window"]
BINDING_NAME_LM_EXCUSE_G	= L["Make an Excuse to Guild"]
BINDING_NAME_LM_EXCUSE_O	= L["Make an Excuse to Officer"]
BINDING_NAME_LM_EXCUSE_P	= L["Make an Excuse to Party"]
BINDING_NAME_LM_EXCUSE_R	= L["Make an Excuse to Raid"]
BINDING_NAME_LM_EXCUSE_S	= L["Make an Excuse to Say"]
BINDING_NAME_LM_EXCUSE_Y	= L["Make an Excuse to Yell"]
BINDING_NAME_LM_EXCUSE_1	= L["Make an Excuse to Channel 1"]
BINDING_NAME_LM_EXCUSE_2	= L["Make an Excuse to Channel 2"]
BINDING_NAME_LM_EXCUSE_3	= L["Make an Excuse to Channel 3"]
BINDING_NAME_LM_EXCUSE_4	= L["Make an Excuse to Channel 4"]
BINDING_NAME_LM_EXCUSE_5	= L["Make an Excuse to Channel 5"]
BINDING_NAME_LM_EXCUSE_6	= L["Make an Excuse to Channel 6"]
BINDING_NAME_LM_EXCUSE_7	= L["Make an Excuse to Channel 7"]
BINDING_NAME_LM_EXCUSE_8	= L["Make an Excuse to Channel 8"]
BINDING_NAME_LM_EXCUSE_9	= L["Make an Excuse to Channel 9"]
BINDING_NAME_LM_EXCUSE_10	= L["Make an Excuse to Channel 10"]
BINDING_NAME_LM_FING       = L["Raid Finger"]
BINDING_NAME_LM_SBUS       = L["Short Bus"]
--
-- Set up the shared SavedVariables.lua defaults.
--

Loudmouth:RegisterDefaults("char", {
  Version = 0, -- Loudmouth.build
  quotes = {
      ["AFK"] = {
		},
		["Crits"] = {
		},
		["Excuses"] = {
		},
		["Fears"] = {
		},
		["Misses"] = {
			--[1] = {
				--["emote"] = 1,
				--["quote"] = "trips and falls.",
			--},
		},
	},
})

Loudmouth:RegisterDefaults("profile", {
  --
  -- Default option values
  --
  Channel = 'Say',
  Debug = 0,
  --
  -- Current State Information
  --
  Version = 0, -- Loudmouth.build
  ActiveSet = "All",
  _QuoteSet = 2,
  _QuoteEvent = 1,
  enabled = {
    ["AFK"] = 1,
    ["Crits"] = 1,
    ["Excuses"] = 1,
	 ["Fears"] = 1,
	 ["Misses"] = 1,
  },
  rates = {
    ["Crits"] = 15,
    ["Fears"] = 33,
    ["Misses"] = 50,
	 ["Wisecrack"] = 15,
  },
  --
  -- Quotes and options
  --
  quotes = {
	 ["Class"] = {
		["DRUID"] = {
      	["AFK"] = { }, ["Crits"] = { }, ["Excuses"] = { }, ["Fears"] = { }, ["Misses"] = { },
		},
		["HUNTER"] = {
      	["AFK"] = { }, ["Crits"] = { }, ["Excuses"] = { }, ["Fears"] = { }, ["Misses"] = { },
		},
	   ["MAGE"] = {
      	["AFK"] = { }, ["Crits"] = { }, ["Excuses"] = { }, ["Fears"] = { }, ["Misses"] = { },
		},
	   ["PALADIN"] = {
      	["AFK"] = { }, ["Crits"] = { }, ["Excuses"] = { }, ["Fears"] = { }, ["Misses"] = { },
		},
		["PRIEST"] = {
      	["AFK"] = { }, ["Crits"] = { }, ["Excuses"] = { }, ["Fears"] = { }, ["Misses"] = { },
		},
		["ROGUE"] = {
      	["AFK"] = { }, ["Crits"] = { }, ["Excuses"] = { }, ["Fears"] = { }, ["Misses"] = { },
		},
		["SHAMAN"] = {
      	["AFK"] = { }, ["Crits"] = { }, ["Excuses"] = { }, ["Fears"] = { }, ["Misses"] = { },
		},
		["WARLOCK"] = {
      	["AFK"] = { }, ["Crits"] = { }, ["Excuses"] = { }, ["Fears"] = { }, ["Misses"] = { },
		},
	 	["WARRIOR"] = {
      	["AFK"] = { }, ["Crits"] = { }, ["Excuses"] = { }, ["Fears"] = { }, ["Misses"] = { },
		},
	 },
    ["Default"] = {
      ["AFK"] = {
        	--[1] = {
				--["emote"] = 0,
				--["quote"] = "Oops, my ethernet cable fell out, and the bits are making a mess on the carpet... brb",
			--},
			--[2] = {
				--["emote"] = 0,
				--["quote"] = "Got a phone call. I won the Lottery. Back after I buy Blizzard to fix a few things...",
			--},
      },
      ["Crits"] = {
        	--[1] = {
				--["emote"] = 0,
				--["quote"] = "I just got a critical hit!",
			--},
			--[2] = {
				--["emote"] = 0,
				--["quote"] = "Oops, my weapon just got stuck in you, could you hand that back please?",
			--},
      },
      ["Excuses"] = {
      	--[1] = {
				--["emote"] = 0,
				--["quote"] = "My g/f just called and wife picked up the phone. Sorry, in combat IRL!"
			--},
      },
      ["Fears"] = {
        	--[1] = {
				--["emote"] = 0,
				--["quote"] = "Hey mob! I didn't say you could leave yet...",
			--},
			--[2] = {
				--["emote"] = 0,
				--["quote"] = "Oh sure, fight me until you think you're gonna lose, then run away like a little girlie...",
			--},
      },
      ["Misses"] = {
        	--[1] = {
				--["emote"] = 0,
				--["quote"] = "Stand still or come closer so I can slap you!",
			--},
			--[2] = {
				--["emote"] = 0,
				--["quote"] = "Oops... I missed.",
			--},
      },
    },
  },
})

--
-- Set up the internal variables, menus and structures that aren't user data
--
local scrollbar = getglobal("LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar")
local statement = nil
local currentquote = {
	["quote"] = "",
	["emote"] = 0,
}
local editlist = { }
local eastereggs = {
  	 ["Bus"] = { ["state"] = 0, ["key"] = "a76b0925cc7563459d0795420efe2d64", },
	 ["Finger"] = { ["state"] = 0, ["key"] = "5922c9c8d78d2f2d958c2305a90d3e4b", },
}
local function eastereggunlock(string)
	Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Eastereggunlock("..(string or "")..")")
	hash = md5:MD5(string)

	for index,table in pairs(eastereggs) do
		if (eastereggs[index]["key"] == hash) then
			eastereggs[index]["state"] = 1
			Loudmouth:Print("Easter Egg "..index.." unlocked.")
			local objectButton = getglobal("LMFrame_Easter_Eggs_"..index.."_Button")
			if (objectButton ~= nil) then
				objectButton:Enable()
				objectButton:Show()
				Loudmouth.UI.buttons["_"..index].hide = false;
			else
				Loudmouth.UI.buttons["_"..index].hide = false;
			end
		end
	end
  --Loudmouth:Update_GUI_Data()
end

--local quotelist = { }
local outputlist = { }
Loudmouth.outputlist = outputlist
--Loudmouth.quotelist = quotelist
Loudmouth.editlist = editlist
Loudmouth.ActiveSet = "";

Loudmouth.Channels = { "UI", "Say", "Party", "Raid", "Guild", "Officer" }
Loudmouth.current_num_quotes=0
Loudmouth.current_button_shown=0
Loudmouth.editing_item=0
Loudmouth.GUI_Update = { }
Loudmouth.hasIcon = true
--
-- Menu text is defined in the localization file. HTT-topic is the
-- Help Topic Title for 'topic' and HTD-topic is the Help Topic Detail.
-- They will appear in the order shown in the help table.
--
Loudmouth.help={
	[1]= { ["title"]=L["HTT-About"],    ["detail"]=L["HTD-About"] },
	[2]= { ["title"]=L["HTT-Abuse"],    ["detail"]=L["HTD-Abuse"] },
	[3]= { ["title"]=L["HTT-Easter"],   ["detail"]=L["HTD-Easter"] },
	[4]= { ["title"]=L["HTT-Emote"],    ["detail"]=L["HTD-Emote"] },
	[5]= { ["title"]=L["HTT-Rates"],    ["detail"]=L["HTD-Rates"] },
	[6]= { ["title"]=L["HTT-RefTgt"],   ["detail"]=L["HTD-RefTgt"] },
	[7]= { ["title"]=L["HTT-SpecQSet"], ["detail"]=L["HTD-SpecQSet"] },
	[8]= { ["title"]=L["HTT-NoQAdd"],   ["detail"]=L["HTD-NoQAdd"] },
	[9]= { ["title"]=L["HTT-QMissing"], ["detail"]=L["HTD-QMissing"] },
	[10]={ ["title"]="Title 10",        ["detail"]="Detail 10" },
	[11]={ ["title"]="Title 11",        ["detail"]="Detail 11" },
	[12]={ ["title"]="Title 12",        ["detail"]="Detail 12" },
	[13]={ ["title"]="Title 13",        ["detail"]="Detail 13" },
	[14]={ ["title"]="Title 14",        ["detail"]="Detail 14" },
	[15]={ ["title"]="Title 15",        ["detail"]="Detail 15" },
	[16]={ ["title"]="Title 16",        ["detail"]="Detail 16" },
	[17]={ ["title"]="Title 17",        ["detail"]="Detail 17" },
	[18]={ ["title"]="Title 18",        ["detail"]="Detail 18" },
	[19]={ ["title"]="Title 19",        ["detail"]="Detail 19" },
	[20]={ ["title"]="Title 20",        ["detail"]="Detail 20" },
	[21]={ ["title"]="Title 21",        ["detail"]="Detail 21" },
	[22]={ ["title"]="Title 22",        ["detail"]="Detail 22" },
}
Loudmouth.hideMenuTitle = true
Loudmouth.LastQuoted = 0
Loudmouth.lastQuoteID = {
	 ["AFK"] = 0,
    ["Crits"] = 0,
	 ["Excuses"] = 0,
	 ["Fears"] = 0,
	 ["Misses"] = 0,
  }
--Loudmouth.loaded = 0
Loudmouth.numTabs = 0 -- will be calculated by GUI_Setup_Frames
Loudmouth.Sets = {
	[1] = "All",
	[2] = "Default",
	[3] = "Char",
	[4] = "Class",
}
Loudmouth.Tabs = {
	[1] = { ["frame"] = "LMFrame_Quote",   ["index"] = 1,
	["init"] = "", ["text"] = "Quotes", },
	[2] = { ["frame"] = "LMFrame_Options", ["index"] = 2,
	["init"] = "Loudmouth:GUI_Setup_Options()", ["text"] = "Options", },
	[3] = { ["frame"] = "LMFrame_Help",    ["index"] = 3,
	["init"] = "Loudmouth:GUI_Setup_Help()", ["text"] = "Help", },
  	[4]= { ["frame"] = "LMFrame_Easter_Eggs",  ["index"] = 4,
	["init"] = "Loudmouth:GUI_Setup_Easter()", ["text"] = "Easter_Eggs", },
	[5] = { ["frame"] = "LMFrame_Edit",  ["index"] = 5,
	["init"] = "Loudmouth:GUI_Setup_Edit()", ["text"] = "Edit", },
}
Loudmouth.UI={
	buttons={
		["_Bus"] = {
			binding = "CTRL-U",
			frame = "Easter_Eggs",
			hide = true,
			index = "_Bus",
			point = "TOPLEFT",
			offsetX = 50,
			offsetY = -75,
			onclick = "Loudmouth:SHORT_BUS()",
			relativeTo = "",
			relativePoint = "TOPLEFT",
			text = "Short Bus",
			width = 120,
		},
		["_Finger"] = {
			binding = "CTRL-F",
			frame = "Easter_Eggs",
			hide = true,
			index = "_Finger",
			point = "TOPLEFT",
			offsetX = 50,
			offsetY = -125,
			onclick = "Loudmouth:FINGER()",
			relativeTo = "",
			relativePoint = "TOPLEFT",
			text = "Shut Up Finger",
			width = 120,
		},
		["_Set_AddName"] = {
			disable = true,
			frame = "Options",
			index = "_Set_AddName",
			point = "LEFT",
			offsetX = 10,
			offsetY = 0,
			relativeTo = "_Set_AddName", 
			relativePoint = "RIGHT",
			text = "Add New Set",
			width = 100,
		},
		["_Set_DeleteName"] = { 
			disable = true,
			frame = "Options",
			index = "_Set_DeleteName",
			inherit = "GameMenuButtonTemplate",
			offsetX = 10,
			offsetY = 0,
			point = "LEFT",
			relativeTo = "_SetList", 
			relativePoint = "RIGHT",
			text = "Delete Set",
			width = 90,
		},
	},
	checkboxes = {
		["_Debugging"] = {
			--checked = Loudmouth.db.profile.Debug,
			onclick = "Loudmouth:GUI_Check_Click(this)",
			frame = "Options",
			index = "_Debugging",
			label = "Debugging",
			labelSide = "LEFT",
			offsetX = -20,
			offsetY = 20,
			point = "BOTTOMRIGHT",
			relativeTo = "",
			relativePoint = "BOTTOMRIGHT",
			updateGUI = "LMFrame_Options_Debugging_CheckBox:SetChecked(Loudmouth.db.profile.Debug)",
		},
		["_Enable"] = {
			onclick = "Loudmouth:GUI_Check_Click(this)",
			frame = "Edit",
			index = "_Enable",
			label = "Ena",
			labelSide = "TOP",
			offsetX = -23,
			offsetY = -42,
			point = "TOPRIGHT",
			relativeTo = "",
			relativePoint = "TOPRIGHT",
			updateGUI = "LMFrame_Edit_Enable_CheckBox:SetChecked(Loudmouth:Get_Event_State(Loudmouth.UI.dropdowns['_EditEvent'].table[Loudmouth.UI.dropdowns['_EditEvent'].selected]));",
		},
	},
	dropdowns={
		["_ActiveSet"] = {
			frame = "Options",
			func = "Loudmouth.db.profile.ActiveSet = Loudmouth.UI.dropdowns['_ActiveSet'].table[Loudmouth.UI.dropdowns['_ActiveSet'].selected];\
				Loudmouth:Update_GUI_Data();",
			--"Loudmouth.db.profile._QuoteSet = Loudmouth.UI.dropdowns['_EditSet'].selected; \
			--if (Loudmouth.UI.dropdowns['_EditSet'].selected ~= 3 and Loudmouth.UI.dropdowns['_EditSet'].selected ~= 4) then \
			--Loudmouth.db.profile.ActiveSet = Loudmouth.UI.dropdowns['_EditSet'].table[Loudmouth.UI.dropdowns['_EditSet'].selected]; \
			--end \
			--Loudmouth.active_set_name = Loudmouth.db.profile.ActiveSet;  \
			--Loudmouth:Update_GUI_Data();",
			index = "_ActiveSet",
			justifyH = "LEFT",
			label = "Active Set",
			offsetX = 16,
			offsetY = -145,
			point = "TOPLEFT",
			relativeTo = "", 
			relativePoint = "TOPLEFT",
			selected = 1,
			table = Loudmouth.Sets,
			width = 93,
		},
		["_Babble"] = { 
			frame = "Options", 
			func = "Loudmouth.db.profile.Channel = Loudmouth.UI.dropdowns['_Babble'].table[Loudmouth.UI.dropdowns['_Babble'].selected]",
			index = "_Babble", 
			--label = "Babble Channel", 
			offsetX = -60,
			offsetY = -115,
			point = "TOPRIGHT",
			relativeTo = "", 
			relativePoint = "TOPRIGHT",
			selected = 1, 
			table = { "UI", "Say", "Party", "Raid", "Guild", "Officer" },
			width = 90,
			updateGUI = "Loudmouth:UI_Dropdown_Select('_Babble',Loudmouth.db.profile.Channel)",
		},
		["_EditEvent"] = {
			frame = "Edit",
			func = "Loudmouth.db.profile._QuoteEvent = Loudmouth.UI.dropdowns['_EditEvent'].selected; \
				LMFrame_Edit_Enable_CheckBox:SetChecked(Loudmouth:Get_Event_State(Loudmouth.UI.dropdowns['_EditEvent'].table[Loudmouth.UI.dropdowns['_EditEvent'].selected]));\
				Loudmouth.edit_event_name = Loudmouth.UI.dropdowns['_EditEvent'].table[Loudmouth.UI.dropdowns['_EditEvent'].selected]; \
				Loudmouth:Get_Quote_Event(Loudmouth.UI.dropdowns['_EditEvent'].table[Loudmouth.UI.dropdowns['_EditEvent'].selected],Loudmouth.editlist,Loudmouth.UI.dropdowns['_EditSet'].table[Loudmouth.UI.dropdowns['_EditSet'].selected]);\
  				Loudmouth:GUI_ListBox_OnShow('LMFrame_Quote_QuoteList');\
				Loudmouth:Update_GUI_Data()",
			index = "_EditEvent",
			justifyH = "LEFT",
			label = "Edit Event",
			offsetX = 140,
			offsetY = -50,
			point = "TOPLEFT",
			relativeTo = "", 
			relativePoint = "TOPLEFT",
			selected = 1,
			table = {
				[1] = "AFK",
				[2] = "Crits",
				[3] = "Excuses",
				[4] = "Fears",
				[5] = "Misses",
			},
			width = 93,
		},
		["_EditSet"] = {
			frame = "Edit",
			func = "Loudmouth.db.profile._QuoteSet = Loudmouth.UI.dropdowns['_EditSet'].selected; \
				Loudmouth.edit_set_name = Loudmouth.UI.dropdowns['_EditSet'].table[Loudmouth.UI.dropdowns['_EditSet'].selected]; \
				Loudmouth:Get_Quote_Event(Loudmouth.UI.dropdowns['_EditEvent'].table[Loudmouth.UI.dropdowns['_EditEvent'].selected],Loudmouth.editlist,Loudmouth.UI.dropdowns['_EditSet'].table[Loudmouth.UI.dropdowns['_EditSet'].selected]);\
  				Loudmouth:GUI_ListBox_OnShow('LMFrame_Quote_QuoteList');\
				Loudmouth:Update_GUI_Data();",
			index = "_EditSet",
			justifyH = "LEFT",
			label = "Edit Quote Set",
			offsetX = 20,
			offsetY = -50,
			point = "TOPLEFT",
			relativeTo = "", 
			relativePoint = "TOPLEFT",
			selected = 1,
			table = Loudmouth.Sets,
			width = 93,
		},
		["_SetList"] = { 
			frame = "Options", 
			index = "_SetList", 
			label = "", 
			offsetX = -3,
			offsetY = -10,
			point = "TOPLEFT",
			relativeTo = "_Set_AddName", 
			relativePoint = "BOTTOMLEFT",
			selected = 1, 
			table = {
				"Choose set",
			}, 
			width = 93,
		},
		["_QuoteEvent"] = { 
			frame = "Quote", 
			index = "_QuoteEvent", 
			label = "Event Type", 
			selected = 2, 
			table = { 
				[1] = "AFK", 
				[2] = "Crits", 
				[3] = "Excuses", 
				[4] = "Fears", 
				[5] = "Misses",
			},
		},
		["_QuoteSet"] = { 
			frame = "Quote", 
			index = "_QuoteSet", 
			label = "Quote Set", 
			selected = 2, 
			table = {
				[1] = "All", 
				[2] = "Default", 
				[3] = "Char", 
				[4] = "Class",
			},
		},
		["_SendQuote"] = { 
			frame = "Quote", 
			index = "_SendQuote", 
			label = "", 
			selected = 1, 
			table = { 
				[1] = "Send on Channel", 
				[2] = "Say", 
				[3] = "Yell", 
				[4] = "Party", 
				[5] = "Raid", 
				[6] = "Guild", 
				[7] = "Officer",
			},
		},
	},
	labels = {
		["_OptBabbleTo"] = {
			font = "GameFontNormalSmall",
			frame = "Options", 
			index = "_OptBabbleTo", 
			justifyH = "LEFT",
			offsetX = -155,
			offsetY = -110,
			point = "TOPRIGHT",
			relativeTo = "", 
			relativePoint = "TOPRIGHT",
			text = "Babble to:",
		},
		--["_OptDebugging"] = {
			--font = "GameFontNormalSmall",
			--frame = "Options", 
			--index = "_OptDebugging", 
			--justifyH = "LEFT",
			--offsetX = 0,
			--offsetY = 0,
			--point = "RIGHT",
			--relativeTo = "_Debug", 
			--relativePoint = "LEFT",
			--text = "Debugging",
		--},
		["_OptQuoteSets"] = {
			font = "GameFontNormalLarge",
			frame = "Options", 
			index = "_OptQuoteSets", 
			--justifyH = "LEFT",
			offsetX = 70,
			offsetY = -45,
			--point = "TOPLEFT",
			--relativeTo = "", 
			--relativePoint = "TOPLEFT",
			text = "Quote Sets",
		},
		["_HelpTitle"] = {
			font = "GameFontNormalLarge",
			frame = "Help", 
			index = "_HelpTitle", 
			--justifyH = "LEFT",
			--offsetX = 70,
			offsetY = -40,
			point = "TOP",
			--relativeTo = "", 
			relativePoint = "TOP",
			text = "Loudmouth Help",
		},
		--["_TopicText_ScrollChild_Title"] = {
			--font = "QuestTitleFont",
			--frame = "Help", 
			--index = "_TopicText_ScrollChild_Title", 
			--offsetX = 35,
			--offsetY = -20,
			--parent = "LMFrame_Help_TopicText_ScrollChild",
			--point = "TOPLEFT",
			--relativeTo = "_TopicText_ScrollChild", 
			--relativePoint = "TOPLEFT",
		--},
		--["_TopicText_ScrollChild_Text"] = {
			--font = "QuestFont",
			--frame = "Help", 
			--index = "_TopicText_ScrollChild_Text", 
			--justifyH = "LEFT",
			--offsetX = 35,
			--offsetY = -50,
			--parent = "LMFrame_Help_TopicText_ScrollChild",
			--relativeTo = "_TopicText_ScrollChild", 
		--},
	},
	listboxes={
		["_QuoteList"] = {
			font = "GameFontNormalSmall",
			frame = "Edit", 
			index = "_QuoteList", 
			justifyH = "CENTER",
			keyField = "quote",
			label = "Quote List - %d quotes",
			offsetX = 20,
			offsetY = -90,
			point = "TOPLEFT",
			relativeTo = "", 
			relativePoint = "TOPLEFT",
			rows = 15,
			scrollindex = 0,
			table = Loudmouth.editlist,
			width = 560,
			updateGUI = "Loudmouth:GUI_Update_ListBox(LMFrame_Edit_QuoteList);",
		},
		["_TopicList"] = {
			onclick = "local results=Loudmouth:GUI_Get_UI_Data(this); \
	 			getglobal(results.basename..results.index..results.suffix..'_Text'):SetTextColor(1,1,1); \
	 			getglobal(results.basename..results.item['selectedindex']..results.suffix..'_Text'):SetTextColor(0.8,0.8,0.3); \
				results.item['selectedindex'] = results.index; \
				LMFrame_Help_TopicText_ScrollChild_Text:SetText(Loudmouth.help[results.item.selectedindex+results.item.scrollindex].detail);\
				getglobal('LMFrame_Help_TopicText_ScrollChild_Title'):SetText(string.gsub(Loudmouth.help[results.item.selectedindex+results.item.scrollindex]['title'],'    ','')); \
				",
			font = "GameFontNormalSmall",
			frame = "Help", 
			index = "_TopicList", 
			keyField = "title",
			justifyH = "CENTER",
			label = "Help Topics",
			offsetX = 20,
			offsetY = -70,
			point = "TOPLEFT",
			relativeTo = "", 
			relativePoint = "TOPLEFT",
			rows = 20,
			scrollindex = 0,
			selectedindex = 1,
			table = Loudmouth.help,
			width = 216,
		},
	},
}
local options = {
  type = 'group',
  args = {
	header = {
	   type = 'header',
	    name = "Quick Actions",
	    icon = "Interface\\AddOns\\Loudmouth\\icon.tga",
	    iconHeight = 16,
	    iconWidth = 16,
	    order = 1,
	},
	spacer = {
		type = 'header',
		name = 'Config Options',
		order = 10,
	},
	spacer2 = {
		type = 'header',
		name = 'Rate Options',
		order = 17,
	},
	afks = {
		type = 'toggle',
		name = L["AFK Messages"],
		desc = L["Whether AFKs messages will be sent"],
		get = function ()
				return Loudmouth:Get_Event_State("AFK") == 1
		end,
		set = function ()
				Loudmouth:Set_Event_State("AFK", 1 - Loudmouth:Get_Event_State("AFK"))
	    		Loudmouth:Update_GUI_Data()
		end,
		order = 12,
	},
	crits = {
	    type = 'toggle',
	    name = L["Crit Hits"],
	    desc = L["Will you brag about critical hits?"],
		get = function ()
				return Loudmouth:Get_Event_State("Crits") == 1
		end,
		set = function ()
				Loudmouth:Set_Event_State("Crits", 1 - Loudmouth:Get_Event_State("Crits"))
	    		Loudmouth:Update_GUI_Data()
	    end,
		order = 13,
	},
	--critrate = {
	    --type = 'range',
	    --name = L["Crit Rate"],
	    --desc = L["How often you brag about critical hits"],
	    --min = 0,
	    --max = 100,
	    --step = 1,
	    --isPercent = false,
	    --get = function ()
	        	--return Loudmouth:Get_Rate("Crits")
	    --end,
	    --set = function (v)
	         --Loudmouth:Set_Rate("Crits",v)
	    		--Loudmouth:Update_GUI_Data()
	    --end,
		--order = 18,
	--},
	excuses = {
		type = 'toggle',
		name = L["Excuse Messages"],
		desc = L["Whether Excuse messages will be sent"],
		get = function ()
				return Loudmouth:Get_Event_State("Excuses") == 1
		end,
		set = function ()
				Loudmouth:Set_Event_State("Excuses", 1 - Loudmouth:Get_Event_State("Excuses"))
	    		Loudmouth:Update_GUI_Data()
		end,
		order = 14,
	},
	fears = {
	    type = 'toggle',
	    name = L["Fear Effects"],
	    desc = L["Will you comment when mobs run away?"],
		get = function ()
				return Loudmouth:Get_Event_State("Fears") == 1
		end,
		set = function ()
				Loudmouth:Set_Event_State("Fears", 1 - Loudmouth:Get_Event_State("Fears"))
	    		Loudmouth:Update_GUI_Data()
	    end,
		order = 15,
	},
	--fearrate = {
	    --type = 'range',
	    --name = L["Fear Rate"],
	    --desc = L["How often you taunt about Feared mobs running away"],
	    --min = 0,
	    --max = 100,
	    --step = 1,
	    --isPercent = false,
	    --get = function ()
	        --return Loudmouth:Get_Rate("Fears")
	    --end,
	    --set = function (v)
	         --Loudmouth:Set_Rate("Fears",v)
	    		--Loudmouth:Update_GUI_Data()
	    --end,
		--order = 19,
	--},
	miss = {
	    type = 'toggle',
	    name = L["Missed Attacks"],
	    desc = L["Will you comment if you miss?"],
		get = function ()
				return Loudmouth:Get_Event_State("Misses") == 1
		end,
		set = function ()
				Loudmouth:Set_Event_State("Misses", 1 - Loudmouth:Get_Event_State("Misses"))
	    		Loudmouth:Update_GUI_Data()
	    end,
		order = 16,
	},
	--missrate = {
	    --type = 'range',
	    --name = L["Missed Attack Rate"],
	    --desc = L["How often you taunt about Missed Attacks"],
	    --min = 0,
	    --max = 100,
	    --step = 1,
	    --isPercent = false,
	    --get = function ()
	        	--return Loudmouth:Get_Rate("Misses")
	    --end,
	    --set = function (v)
	         --Loudmouth:Set_Rate("Misses",v)
	    		--Loudmouth:Update_GUI_Data()
	    --end,
		--order = 20,
	--},
	modmark = {
		type = 'toggle',
		name = 'mark Enabled',
		desc = 'mark Module Enabled',
		--usage = "<module>",
		get = function()
		  return Loudmouth:IsModuleActive("Mark",true)
		end,
		set = function()
		  if Loudmouth:IsModuleActive("Mark",true) then
		    Loudmouth:ToggleModuleActive("Mark",false)
		  else
		    Loudmouth:ToggleModuleActive("Mark",true)
		  end
		end,
	},
	modmovies = {
		type = 'toggle',
		name = 'Movies Enabled',
		desc = 'Movies Module Enabled',
		--usage = "<module>",
		get = function()
		  return Loudmouth:IsModuleActive("LoudmouthMovies",true)
		end,
		set = function()
		  if Loudmouth:IsModuleActive("LoudmouthMovies",true) then
		    Loudmouth:ToggleModuleActive("LoudmouthMovies",false)
		  else
		    Loudmouth:ToggleModuleActive("LoudmouthMovies",true)
		  end
		end,
	},
	modREG = {
		type = 'toggle',
		name = 'REG Enabled',
		desc = 'REG Module Enabled',
		--usage = "<module>",
		get = function()
		  return Loudmouth:IsModuleActive("LoudmouthREG",true)
		end,
		set = function()
		  if Loudmouth:IsModuleActive("LoudmouthREG",true) then
		    Loudmouth:ToggleModuleActive("LoudmouthREG",false)
		  else
		    Loudmouth:ToggleModuleActive("LoudmouthREG",true)
		  end
		end,
	},
	channel = {
	    type = 'text',
	    name = L["Babble Channel"],
	    desc = L["Babble randomly in selected channel"],
	    get = function()
	        	return Loudmouth.db.profile.Channel
	    end,
	    set = function(v)
	        	Loudmouth.db.profile.Channel = v
				Loudmouth:Update_GUI_Data()
	    end,
	    validate = Loudmouth.Channels,
		order = 11,
	},
	wisecrack = {
	    type = 'range',
	    name = L["Wisecrack Cooldown"],
	    desc = L["Minimum time between Wisecracks."],
	    min = 5,
	    max = 300,
	    step = 5,
	    isPercent = false,
	    get = function ()
	        	return Loudmouth.db.profile.rates["Wisecrack"]
	    end,
	    set = function (v)
	         Loudmouth.db.profile.rates["Wisecrack"] = v
	    		Loudmouth:Update_GUI_Data()
	    end,
		order = 21,
	},
	afk = {
		type = 'execute',
		name = L["Send AFK Message"],
		desc = L["Send an AFK Message in Guild chat, and raid or party"],
		func = function()
		  		Loudmouth:Output_AFK("FORCE")
		end,
		order = 2,
	},
	excuse = {
		--type = 'group',
		type = 'text',
		name = L["Make Excuse"],
		desc = L["Send an excuse to Guild and default babble channel"],
		--pass = true,
		usage = "<channel>",
		input = false,
		get = false,
		set = function(x)
				--if (x == "guild") then
					Loudmouth:Output_Excuse(x,"FORCE")
				--end
			  --Loudmouth:Output_Excuse()
		end,
		order = 3,
	   validate = { "-", "UI", "Say", "Yell", "Party", "Raid", "Guild", "Officer", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "g", "o", "p", "r", "s", "y", },
	},
	help = {
		type = 'execute',
		name = L["Show Help"],
		desc = L["Show the Help Pane"],
		func = function()
		  if (not LMFrame:IsShown()) then
		  	LMFrame:Show()
		  end
		  if LMFrame.selectedTab ~= Loudmouth:GUI_Get_Tab_Index("Help") then
		  	LMFrame.selectedTab = Loudmouth:GUI_Get_Tab_Index("Help")
  			PanelTemplates_UpdateTabs(LMFrame)
			Loudmouth:GUI_Tab_OnClick()
		  end
		end,
		order = 5,
	},
	gui = {
		type = 'execute',
		name = L["Show GUI"],
		desc = L["Display GUI Window"],
		func = function()
				Loudmouth:Update_GUI_Data()
		  		Loudmouth:GUI_Show()
		end,
		order = 4,
	},
	hide = {
	   type = 'execute',
	   name = L["Hide GUI"],
	   desc = L["Close GUI Window"],
	   func = function() LMFrame:Hide() end,
		order = 9,
	},
	options = {
		type = 'execute',
		name = L["Show Options"],
		desc = L["Show the Options Pane"],
		func = function()
		  if (not LMFrame:IsShown()) then
		  	LMFrame:Show()
		  end
		  if LMFrame.selectedTab ~= Loudmouth:GUI_Get_Tab_Index("Options") then
		  	LMFrame.selectedTab = Loudmouth:GUI_Get_Tab_Index("Options")
  			PanelTemplates_UpdateTabs(LMFrame)
			Loudmouth:GUI_Tab_OnClick()
		  end
		end,
		order = 6,
	},
	quotes = {
		type = 'execute',
		name = L["Show Quotes"],
		desc = L["Show the Quotes Pane"],
		func = function()
		  if (not LMFrame:IsShown()) then
		  	LMFrame:Show()
		  end
		  if LMFrame.selectedTab ~= Loudmouth:GUI_Get_Tab_Index("Quotes") then
		  	LMFrame.selectedTab = Loudmouth:GUI_Get_Tab_Index("Quotes")
  			PanelTemplates_UpdateTabs(LMFrame)
			Loudmouth:GUI_Tab_OnClick()
		  end
		end,
		order = 7,
	},
	state = {
	   type = 'execute',
	   name = L["Show Status"],
	   desc = L["Show Command Line Status"],
		func = function()
		 		Loudmouth:Output_Command_Line_Status()
		end,
		order = 8,
	},
  },
}

-- This function takes a table and returns the index that matches
-- the value passed, nil if no match

function table_find(table,needle)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"table_find(",table,",",needle,");");
  local index,value

  if (#table) then
  		for index = 1, #table, 1 do
			if (table[index] == needle) then
				return index
			end
		end
  end
  for index,value in pairs(table) do
  		if (value == needle) then
			return index
		end
  end
  return nil
end

--
-- Set up ACE and Fubar menus
--

Loudmouth:RegisterChatCommand({"/loudmouth","/lm"}, options)
Loudmouth.OnMenuRequest = options

--
-- Ace / Fubar Interface handlers
--

-- If you Left Click on FUBAR icon/text...
function Loudmouth:OnClick()
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:OnClick();");
  if (LMFrame:IsShown()) then
    LMFrame:Hide()
  else
    Loudmouth:GUI_Show() 
  end
end

--function Loudmouth:OnMenuRequest()
  --self:AddImpliedMenuOptions()
--end

-- Let's build a nice tooltip showing the current state...
function Loudmouth:OnTooltipUpdate()
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:OnTooltipUpdate();");
  local WisecrackCooldown

  local cat = tablet:AddCategory(
    'text', L["Loudmouth"].." "..L["version"], 'text2', Loudmouth.build,
	 'columns', 2,
    'child_textR' , 1, 'child_textG' , 1, 'child_textB' , 0,
    'child_textR2', 1, 'child_textG2', 1, 'child_textB2', 0
  )
  cat:AddLine( 'text', '', 'text2', '')

  local cat = tablet:AddCategory(
    'text', L["Event Type"], 'text2', L["Response Rates"],
	 'columns', 2,
    'child_textR' , 1, 'child_textG' , 1, 'child_textB' , 0,
    'child_textR2', 1, 'child_textG2', 1, 'child_textB2', 0
  )
  if (self:Get_Event_State("AFK") == 1) then
    cat:AddLine( 'text', L["AFK Messages"], 'text2', self:Get_Rate("AFK"))
  end
  if (self:Get_Event_State("Crits") == 1) then
    cat:AddLine( 'text', L["Crit Hits"], 'text2', self:Get_Rate("Crits"))
  end
  if (self:Get_Event_State("Excuses") == 1) then
    cat:AddLine( 'text', L["Excuse Messages"], 'text2', self:Get_Rate("Excuses"))
  end
  if (self:Get_Event_State("Fears") == 1) then
    cat:AddLine( 'text', L["Fear Effects"], 'text2', self:Get_Rate("Fears"))
  end
  if (self:Get_Event_State("Misses") == 1) then
    cat:AddLine( 'text', L["Missed Attacks"], 'text2', self:Get_Rate("Misses"))
  end
  local cat = tablet:AddCategory(
    'text', L["Configuration"], 'columns', 2,
    'child_textR' , 1, 'child_textG' , 1, 'child_textB' , 0,
    'child_textR2', 0, 'child_textG2', 1, 'child_textB2', 1
  )
  cat:AddLine( 'text', L["Babble Channel"], 'text2', self.db.profile.Channel)
  cat:AddLine( 'text', L["Number of Quotes"], 'text2', self.current_total_quotes)
  local activeset
  --if (self.active_set_name == "Char" or self.active_set_name == "Class") then
    --activeset = self.db.profile.ActiveSet
  --else
    --activeset = self.current_set_name
  --end
  cat:AddLine( 'text', L["Quote Set in Use"], 'text2', self.db.profile.ActiveSet)
  if (self:IsDebugging() == true) then
    WisecrackCooldown = L["Disabled"]
  else
    WisecrackCooldown = self.db.profile.rates["Wisecrack"]..L[" seconds"]
  end
  cat:AddLine( 'text', L["Wisecrack Cooldown"], 'text2', WisecrackCooldown)

  local cat = tablet:AddCategory(
    'text', L["Cooldowns"], 'columns', 2,
    'child_textR' , 1, 'child_textG' , 1, 'child_textB' , 0,
    'child_textR2', 0, 'child_textG2', 1, 'child_textB2', 1
  )
  if ((GetTime() - self.LastQuoted) > self.db.profile.rates["Wisecrack"]) then	
  			cat:AddLine( 'text', L["Wisecrack Cooldown"], 'text2', L["Ready"])
  else
  			local left = self.db.profile.rates["Wisecrack"] - (GetTime() - self.LastQuoted)
  			cat:AddLine( 'text', L["Wisecrack Cooldown"], 'text2', floor(left))
  end
  if (eastereggs['Bus']["state"] == 1) then
  		local bus = GetTime() - (self.LastBussed or 0)
		if (bus > 60) then
			bus = L["Ready"]
			LMFrame_Easter_Eggs_Bus_Button:Enable()
		else
			bus = (60-floor(bus)).." "..L["seconds"]
			LMFrame_Easter_Eggs_Bus_Button:Disable()
		end
  		cat:AddLine( 'text', L["Short Bus"], 'text2', bus)
	end
	if (eastereggs['Finger']["state"] == 1) then
  		local fing = GetTime() - (self.LastFingered or 0)
		if (fing > 60) then
			fing = L["Ready"]
			LMFrame_Easter_Eggs_Finger_Button:Enable()
		else
			fing = (60-floor(fing)).." "..L["seconds"]
			LMFrame_Easter_Eggs_Finger_Button:Disable()
		end
  		cat:AddLine( 'text', L["Raid Finger"], 'text2', fing)
  end

  --local hours,minutes = GetGameTime();
  --cat:AddLine( 'text', L["Game Time"], 'text2', hours..":"..minutes)
  --cat:AddLine( 'text', L["System Uptime"], 'text2', GetTime())
  tablet:SetTitle(L["Loudmouth"])
  tablet:SetHint(L["Left click to bring up the configuration window. Right click to edit options."])
  if (self:IsDebugging() == true) then
    self.db.profile.Debug = 1
  else
    self.db.profile.Debug = 0
  end
end

function Loudmouth:Output_Command_Line_Status()
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:Output_Command_Line_Status();");
  local eventTypes = ""
  local responseTypes = ""
  local channelName = ""
  local setList = ""
  local set,table

  for k,v in pairs(self.db.profile.enabled) do
    if (v)
	 then	eventTypes = eventTypes.." "..crayon:Colorize("00cf00",k)
	 else	eventTypes = eventTypes.." "..crayon:Colorize("ff0000",k)
	 end
  end
  for k,v in pairs(self.db.profile.rates) do
    --if (self:Get_Event_State(k) == true)
    if (self:Get_Event_State(k)==1)
	 then
    responseTypes = responseTypes.." "..crayon:Colorize("00cf00",k).."="..crayon:Colorize("00cf00",v)
	 else
    responseTypes = responseTypes.." "..crayon:Colorize("ff0000",k).."="..crayon:Colorize("ff0000",v)
	 end
  end
  if (self.db.profile.Channel == "Raid")
  then channelName = crayon:Colorize("ff4f2f","Raid")
  elseif (self.db.profile.Channel == "Party")
  then channelName = crayon:Colorize("7f9fff","Party")
  elseif (self.db.profile.Channel == "Say")
  then channelName = crayon:Colorize("ffffff","Say")
  elseif (self.db.profile.Channel == "UI")
  then channelName = crayon:Colorize("ffffff","UI")
  elseif (self.db.profile.Channel == "Guild")
  then channelName = crayon:Colorize("00ff00","Guild")
  elseif (self.db.profile.Channel == "Officer")
  then channelName = crayon:Colorize("00bf00","Officer")
  end

  for set,table in pairs(self.db.profile.quotes) do
    if (set ~= "Class") then
	 	setList = setList.." "..set
	 end
  end

  self:Print(L["Loudmouth"].." "..self.build.." "..L["status"]..":")
  self:Print("  "..L["Event Type"].."s:"..eventTypes)
  self:Print("  "..L["Response Rates"]..":"..responseTypes)
  self:Print("  "..L["Babble Channel"]..": "..channelName)
  self:Print("  "..L["Number of Quotes"]..": "..crayon:Colorize("9f9fff",self.current_total_quotes))
  self:Print("  "..L["Quote Set in Use"]..": "..crayon:Colorize("00bf00",self.db.profile.ActiveSet))
  self:Print("  "..L["Quote Sets Available"]..":"..crayon:Colorize("9f9fff",setList))
  self:Print("  "..L["Wisecrack Cooldown"]..": "..crayon:Colorize("9f9fff",self.db.profile.rates["Wisecrack"].." "..L["seconds"]))

  if (self:IsDebugging() == true) then
    self.db.profile.Debug = 1
  else
    self.db.profile.Debug = 0
  end
end

--
-- ACE core functions
--

--function Loudmouth:OnLoad()
  --self:Debug(L["Loudmouth"].." loaded.")
--end

function Loudmouth:OnCommReceive(prefix,sender,distribution,command,arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9,arg10,arg11,arg12,arg13,arg14,arg15,arg16)
	local result

	self:CustomLevelDebug(1,0,1,0,Loudmouth.dataFrame,nil,"< "..distribution..":"..sender.." "..command.."("..(arg1 or "").." "..(arg2 or "").." "..(arg3 or "").." "..(arg4 or "").." "..(arg5 or "").." "..(arg6 or "").." "..(arg7 or "").." "..(arg8 or "").." "..(arg9 or "").." "..(arg10 or "").." "..(arg11 or "").." "..(arg12 or "").." "..(arg13 or "").." "..(arg14 or "").." "..(arg15 or "").." "..(arg16 or "")..").")

	if (command == "Bus" and distribution == "GUILD") then
		if (self.LastBussed ~= nil and arg1 ~= nil and self.LastBussed < arg1) then
			if (eastereggs['Bus']["state"]==1) then
				self:CustomLevelDebug(1,1,1,1,Loudmouth.dataFrame,nil,"Last Bus was sent "..floor(arg1).." seconds ago.")
			end
			self.LastBussed = GetTime() - arg1
		else
			self.LastBussed = GetTime() - (arg1 or 0)
			if (eastereggs['Bus']["state"]==1) then
				self:CustomLevelDebug(1,1,1,1,Loudmouth.dataFrame,nil,"Last Bus was sent "..floor(arg1 or 0).." seconds ago.")
			end
		end
  		Loudmouth:StartMetro("Loudmouth",67)
	end
	if (command == "Fing" and distribution == "GUILD") then
		if (self.LastFingered ~= nil and arg1 ~= nil and self.LastFingered < arg1) then
			if (eastereggs['Bus']["state"]==1) then
				self:CustomLevelDebug(1,1,1,1,Loudmouth.dataFrame,nil,"Last Fing was sent "..floor(arg1).." seconds ago.")
			end
			self.LastFingered = GetTime() - arg1
		else
			self.LastFingered = GetTime() - (arg1 or 0)
			if (eastereggs['Bus']["state"]==1) then
				self:CustomLevelDebug(1,1,1,1,Loudmouth.dataFrame,nil,"Last Fing was sent "..floor(arg1 or 0).." seconds ago.")
			end
		end
  		Loudmouth:StartMetro("Loudmouth",67)
	end
	if (command == "Loaded" and distribution == "GUILD") then
		result = self:SendPrioritizedCommMessage("NORMAL","GUILD","Bus",GetTime() - (self.LastBussed or 0))
		self:CustomLevelDebug(1,0,1,0,Loudmouth.dataFrame,nil,"-> GUILD: Bus "..GetTime() - (self.LastBussed or 0)..".")
		if (result == false) then self:CustomLevelDebug(1,1,0,0,Loudmouth.dataFrame,nil,"GUILD Data Channel failed.") end
		result = self:SendPrioritizedCommMessage("NORMAL","GUILD","Fing",GetTime() - (self.LastFingered or 0))
		self:CustomLevelDebug(1,0,1,0,Loudmouth.dataFrame,nil,"-> GUILD: Fing "..GetTime() - (self.LastFingered or 0)..".")
		if (result == false) then self:CustomLevelDebug(1,1,0,0,Loudmouth.dataFrame,nil,"GUILD Data Channel failed.") end
		result = self:SendPrioritizedCommMessage("NORMAL","GUILD","Version",self.build)
		self:CustomLevelDebug(1,0,1,0,Loudmouth.dataFrame,nil,"-> GUILD: Version "..self.build..".")
		if (result == false) then self:CustomLevelDebug(1,1,0,0,Loudmouth.dataFrame,nil,"GUILD Data Channel failed.") end
  		Loudmouth:StartMetro("Loudmouth",67)
	end
	if (command == "Lock" and distribution == "GUILD") then
		self.LastBussed = 2147483646
		self.LastFingered = 2147483646
  		Loudmouth:StopMetro("Loudmouth")
	end
	if (command == "Reset" and distribution == "GUILD") then
		self.LastBussed = nil
		self.LastFingered = nil
  		Loudmouth:StopMetro("Loudmouth")
	end
	if (command == "Upgrade" and self.upgradeNotify ~= 1) then
		self:Print("Loudmouth is now up to Version "..(arg1 or "").." build "..(arg2 or "")..". Please upgrade by downloading from files.wowace.com/.")
		self.upgradeNotify=1
	end
	if (command == "Version" and arg1 < self.build) then
		result = self:SendPrioritizedCommMessage("NORMAL","WHISPER",sender,"Upgrade",self.Version,self.build)
		self:CustomLevelDebug(1,0,1,0,Loudmouth.dataFrame,nil,"-> "..sender..": Version "..self.Version.." build "..self.build..".")
		if (result == false) then self:CustomLevelDebug(1,1,0,0,Loudmouth.dataFrame,nil,"GUILD Data Channel failed.") end
	end
	if (command == "Version" and arg1 > self.build and self.upgradeNotify ~= 1) then
		self:Print("Loudmouth is now up to build "..(arg1 or "")..". Please upgrade by downloading from files.wowace.com/.")
		self.upgradeNotify=1
	end
end

function Loudmouth:OnDisable()
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:OnDisable();");
  self:Print("Loudmouth Disabling...");
end

function Loudmouth:OnEnable() -- Called when the addon is enabled
  -- Enable debugging first if active
  --self:SetDebugging(true)
  --self:SetDebugging(self.db.profile.Debug == 1)
  if (self:IsDebugging() == true) then
    self.db.profile.Debug = 1
  else
    self.db.profile.Debug = 0
  end
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:OnEnable();");
  -- Show critical info for troubleshooting
  --LMFrame_build:SetText(self.updated)
  LMFrame_Title:SetText(L["Loudmouth"]);
  LMFrame_Version:SetText(L["revision"].." "..Loudmouth.build..Loudmouth.updated.." "..Loudmouth.date)
  self.ActiveSet = self.db.profile.ActiveSet
  self.UI.dropdowns['_ActiveSet'].selected = table_find(self.Sets,self.ActiveSet)
  self.edit_event_id=self.db.profile["_QuoteEvent"]
  self.edit_event_name=self.UI.dropdowns["_QuoteEvent"].table[self.db.profile["_QuoteEvent"]]
  self.edit_set_name=self.UI.dropdowns["_QuoteSet"].table[self.db.profile["_QuoteSet"]]
  -- Set up the GUI interface first, that way all objects are defined
  LMFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile="Interface/DialogFrame/UI-DialogBox-Border", tileSize=16, edgeSize=16})
  LMFrame:SetBackdropColor(0,0,0,1)
  -- Clean up the quotes db
  Loudmouth:Vasectomy() -- Clean up the quotes db
  -- Build GUI
  self:GUI_Setup_Frames()
  PanelTemplates_SetNumTabs(LMFrame,#self.Tabs)
  LMFrame.selectedTab=1;
  PanelTemplates_UpdateTabs(LMFrame)
  -- Check for upgrade
  if (self.db.profile.Version ~= 0 and self.db.profile.Version ~= Loudmouth.build) then
    self:OnUpgrade()
  	 self.db.profile.Version = Loudmouth.build
  end
  if (self.db.profile.Version == 0) then
    self.db.profile.Version = Loudmouth.build
  end
  -- Collect character information needed
  _,self.className = UnitClass("Player")
  -- populate current state
  self:Auto_Vars()
  self.LastQuoted = GetTime()
  self.current_total_quotes = self:Num_Quotes()
  self.current_button_shown = 0
  -- Set up the Timer Hooks
  self:RegisterMetro("Loudmouth",Loudmouth.TimerTick,0.9,Loudmouth)
  -- Populate our data to the GUI
  self:Update_GUI_Data()
  -- Set some frame LMFrame_Quote cleanup that needs to occur until converted
  -- to dynamic GUI build
  LMFrame_Quote_QuoteList_Highlight_Texture:SetVertexColor(0.70, 0.70, 0.20)
  LMFrame_Quote_QuoteEditLeft:SetTexture()
  LMFrame_Quote_QuoteEditRight:SetTexture()
  LMFrame_Quote_QuoteEditMiddle:SetTexture()
  LMFrame_Quote_QuoteEdit:SetTextInsets(5,5,5,5)
  LMFrame_Quote_QuoteEdit:SetMultiLine(true)
  LMFrame_Quote_QuoteEdit:ClearAllPoints()
  LMFrame_Quote_QuoteEdit:SetPoint("TOPLEFT",LMFrame_Quote,"BOTTOMLEFT",20, 90)
  LMFrame_Quote_QuoteEdit:SetPoint("BOTTOMRIGHT",LMFrame_Quote,"BOTTOMRIGHT",-36, 32)
  LMFrame_Quote_QuoteEdit:SetHeight(58)
  LMFrame_Quote_Rate_SliderLow:SetText("0")
  LMFrame_Quote_Rate_SliderHigh:SetText("100")
  LMFrame_Quote_Rate_Slider:SetMinMaxValues(0,100)
  LMFrame_Quote_Rate_Slider:SetValueStep(1)
  -- Ok, everything should be ready, let's start 'er up and see what happens!
  self:RegisterComm(self.commPrefix, "GUILD")
  self:RegisterComm(self.commPrefix, "GROUP")
  self:RegisterComm(self.commPrefix, "WHISPER")
  self:RegisterMyEvents()
  local lmloadresult = self:SendCommMessage("GUILD","Loaded")
  self:CustomLevelDebug(1,0,1,1,Loudmouth.dataFrame,nil,"-> GUILD: Loaded.")
  if (lmloadresult == false) then
  	self:Print("Loudmouth: Guild COMM failed!")
  end
  --unlock = "new string"
  --self:Print("MD5 Hash of '"..unlock.."' is "..md5:MD5(unlock))
end

function Loudmouth:OnUpgrade()
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:OnUpgrade();");
  -- This section called if upgrading from 0.3
  if (self.db.profile.critrate ~= nil) then	
    self.db.profile.rates["Crits"]=self.db.profile.critrate
  	 table.remove(self.db.profile,critrate)
	 self:Print(L["Upgrading from 0.3"]);
  end
  if (self.db.profile.fearrate ~= nil) then	
    self.db.profile.rates["Fears"]=self.db.profile.fearrate
  	 table.remove(self.db.profile,fearrate)
  end
  if (self.db.profile.missrate ~= nil) then	
    self.db.profile.rates["Misses"]=self.db.profile.missrate
  	 table.remove(self.db.profile,missrate)
  end

  -- This section called if upgrading from < 0.6
  if (self.db.profile.crits) then	
    self.db.profile.enabled["Crits"] = self.db.profile.crits
  	 table.remove(self.db.profile,crits)
	 self:Print(L["Upgrading from below 0.6"]);
  end
  if (self.db.profile.fears) then	
    self.db.profile.enabled["Fears"] = self.db.profile.fears
  	 table.remove(self.db.profile,fears)
  end
  if (self.db.profile.miss) then	
    self.db.profile.enabled["Misses"] = self.db.profile.miss
  	 table.remove(self.db.profile,miss)
  end

  -- This section called if upgrading from < 0.8
  if (tonumber(self.db.profile.Version) < 0.8) then
    self:Print(L["Upgrading from below 0.8"])
    local set, event, index, value, value2, value3
    for set,value in pairs(self.db.profile.quotes) do
      self:Print("Working in Quote Set: "..set)
		if (not self.db.profile.quoteopts) then
		  self.db.profile.quoteopts = {}
		end
		if (not self.db.profile.quoteopts[set]) then	
		  self.db.profile.quoteopts[set] = {}
		end
  	   for event,value2 in pairs(self.db.profile.quotes[set]) do
        self:Print("Working in Quote Event: "..event)
		  if (not self.db.profile.quoteopts[set][event]) then	
		    self.db.profile.quoteopts[set][event] = {}
		  end
	 	  for index,value3 in pairs(self.db.profile.quotes[set][event]) do
          self:Print("Working in Quote Index: "..index)
		    if (not self.db.profile.quoteopts[set][event][index]) then	
			   self.db.profile.quoteopts[set][event][index] = {}
		    end
		    if (not self.db.profile.quoteopts[set][event][index]["emote"]) then	
			   self.db.profile.quoteopts[set][event][index]["emote"] = 0
		    end
		  end -- for index
	   end -- for event
    end -- for set
  end -- upgrade to 0.8

  -- This section called if upgrading from < 0.804
  if (tonumber(self.db.profile.Version) < 0.804) then
    self:Print(L["Upgrading from below 0.804"])
	 local set, event, index, index2, thisquote, value, value2, value3
	 for set, value in pairs(self.db.profile.quotes) do
	   self:Print("Working in Quote Set: "..set)
		for event, value2 in pairs(self.db.profile.quotes[set]) do
        self:Print("Working in Quote Event: "..event)
		  index2 = 1
		  for index, value3 in pairs(self.db.profile.quotes[set][event]) do
          self:Print("Working in Quote: "..index)
			 if (self.db.profile.quotes[set][event][index] ~= nil) then
			   if (not self.db.profile.quotes[set][event][index]["quote"]) then
		        thisquote = self.db.profile.quotes[set][event][index]
			     self.db.profile.quotes[set][event][index2] = {}
			     self.db.profile.quotes[set][event][index2]["quote"] = thisquote
			   end
			   if (not self.db.profile.quoteopts or not self.db.profile.quoteopts[set] or not self.db.profile.quoteopts[set][event] or not self.db.profile.quoteopts[set][event][index]) then
			     self.db.profile.quotes[set][event][index2]["emote"] = 0
			   else
			     self.db.profile.quotes[set][event][index2]["emote"] = self.db.profile.quoteopts[set][event][index]["emote"]
			   end
				index2 = index2 + 1
			 end -- index is nil
		  end -- for index
		  for index = index2, #self.db.profile.quotes[set][event] do
		    table.remove(self.db.profile.quotes[set][event],index)
		  end -- for index
		end -- for event
	 end -- for set
	 self.db.profile.quoteopts = nil
  end -- upgrade to 0.804

  --This section called if upgrading from < 0.806
  if (tonumber(self.db.profile.Version) < 0.806) then
    self:Print(L["Upgrading from below 0.806"])
	 if (self.db.profile.enabled["AFK"] == false) then
      self.db.profile.enabled["AFK"] = 0
	 end
	 if (self.db.profile.enabled["AFK"] == true) then
      self.db.profile.enabled["AFK"] = 1
	 end
	 if (self.db.profile.enabled["Crits"] == false) then
      self.db.profile.enabled["Crits"] = 0
	 end
	 if (self.db.profile.enabled["Crits"] == true) then
      self.db.profile.enabled["Crits"] = 1
	 end
	 if (self.db.profile.enabled["Excuses"] == false) then
      self.db.profile.enabled["Excuses"] = 0
	 end
	 if (self.db.profile.enabled["Excuses"] == true) then
      self.db.profile.enabled["Excuses"] = 1
	 end
	 if (self.db.profile.enabled["Fears"] == false) then
      self.db.profile.enabled["Fears"] = 0
	 end
	 if (self.db.profile.enabled["Fears"] == true) then
      self.db.profile.enabled["Fears"] = 1
	 end
	 if (self.db.profile.enabled["Misses"] == false) then
      self.db.profile.enabled["Misses"] = 0
	 end
	 if (self.db.profile.enabled["Misses"] == true) then
      self.db.profile.enabled["Misses"] = 1
	 end
  end -- upgrade to 0.806

  --This section called if upgrading from < 0.807
  if (tonumber(self.db.profile.Version) < 0.807) then
    self:Print(L["Upgrading from below 0.807"])
	 if (self.db.profile.quoteopts) then
	 	self.db.profile.quoteopts = nil
	 end
  end -- upgrade to 0.807

  self:Print(L["Upgrading data structures from build "]..self.db.profile.Version..L[" to "]..Loudmouth.build)
end

function Loudmouth:TimerTick()
  Loudmouth:Update_GUI_Data()
end

--
-- Generic Table Functions
--

--
-- Loudmouth UI construction code
--

function Loudmouth:GUI_Get_UI_Data(element)
  local basename,sequence,suffix;
  local elementname = "";
  if (element ~= nil) then
	elementname=element:GetName();
  	basename,sequence,suffix=string.match(elementname,'([^0-9]*)([0-9]*)([^0-9]*)');
  end
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:GUI_Get_UI_Data(",elementname,");");
  local class,index,frame,item,search
  local results = { };

  results.basename = basename or ""
  results.index = tonumber(sequence) or 1
  results.suffix = suffix or ""

  for class,_ in pairs(Loudmouth.UI) do
  		for index,_ in pairs(Loudmouth.UI[class]) do
			search="LMFrame_"..Loudmouth.UI[class][index]['frame']..index
			if (string.find(elementname,search) ~= nil) then
				results.item = Loudmouth.UI[class][index]
				return results
			end -- found it
		end -- Index
  end -- Class
  return results
end

function Loudmouth:GUI_Update_ListBox(box)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:GUI_Update_ListBox(",box:GetName(),");");
  local result = self:GUI_Get_UI_Data(box)
  local base = "LMFrame_"..result.item['frame']..result.item['index']
  local i
  local text

  result.item['scrollindex'] = getglobal(base.."_ScrollFrame_ScrollBar"):GetValue()

  for i=1, result.item['rows'] do
  		if (result.item.table[i+result.item['scrollindex']]) then
			if (result.item['keyField']) then
				text = result.item.table[i+result.item['scrollindex']][result.item['keyField']]
			else
				text = result.item.table[i+result.item['scrollindex']]
			end
			getglobal(base.."_Button"..i.."_Text"):SetText(text)
		else
			getglobal(base.."_Button"..i.."_Text"):SetText("")
		end
	 	if ((i+result.item['scrollindex']) == result.item['selectedindex']) then
	 		getglobal(base.."_Button"..i.."_Text"):SetTextColor(1.0, 1.0, 1.0)
	 	else
	 		getglobal(base.."_Button"..i.."_Text"):SetTextColor(0.8, 0.8, 0.3)
	 	end
  end
  result.item['scrollthumb']:Hide()
  result.item['scrolldown']:Disable()
  result.item['scrollup']:Disable()

  if (#result.item['table'] > result.item['rows']) then
  		result.item['scrolldown']:Enable()
  		result.item['scrollthumb']:Show()
		result.item['scrollbar']:SetMinMaxValues(0,#result.item['table']-result.item['rows'])
  end
  if (result.item['scrollindex']+result.item['rows'] == #result.item['table']) then
  		result.item['scrolldown']:Disable()
  end
  if (result.item['scrollindex'] > 0) then
  		result.item['scrollup']:Enable()
  		result.item['scrollthumb']:Show()
  end
end

function Loudmouth:GUI_Build_ListBox(listName,item)
--length,width,dataTable,updateFrame)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:GUI_Build_ListBox(",listName,item.index,");");
  local i
  local scroller = getglobal(listName)
  local scrollframe,slider

  scrollframe = CreateFrame("ScrollFrame",listName.."_ScrollFrame",scroller,"LM_ScrollFrameTemplate")
  scrollframe:SetFrameLevel(scroller:GetFrameLevel()+1)
  scrollframe:SetWidth(16)
  scrollframe:SetPoint("TOPLEFT",scroller,"TOPRIGHT",-24,-2)
  scrollframe:SetPoint("BOTTOMLEFT",scroller,"BOTTOMRIGHT",-24,35)
  slider = getglobal(scrollframe:GetName().."_ScrollBar")
  slider:SetMinMaxValues(0,0)
  slider:SetValue(0)
  slider:SetValueStep(1)

  item['scrollbar']=getglobal(scroller:GetName().."_ScrollFrame_ScrollBar")
  item['scrollthumb']=getglobal(scroller:GetName().."_ScrollFrame_ScrollBar_ThumbTexture")
  item['scrolldown']=getglobal(scroller:GetName().."_ScrollFrame_ScrollBar_ScrollDownButton")
  item['scrollup']=getglobal(scroller:GetName().."_ScrollFrame_ScrollBar_ScrollUpButton")
  item['scrollthumb']:Hide()
  item['scrolldown']:Disable()
  item['scrollup']:Disable()

  --self:Print("Size of table: "..#item['table'])

  if (#item['table'] > item['rows']) then
  		item['scrolldown']:Enable()
  		item['scrollthumb']:Show()
		item['scrollbar']:SetMinMaxValues(0,#item['table']-item['rows'])
  end
  if (item['scrollindex'] > 0) then
  		item['scrollup']:Enable()
  		item['scrollthumb']:Show()
  end

  for i=1, item['rows'] do
    button=CreateFrame("Button",listName.."_Button"..i,scroller)
	 button:SetWidth(item["width"]-29)
	 button:SetFrameLevel(scrollframe:GetFrameLevel()+1)
	 button:SetHeight(16)
	 if (i > 1) then
	   button:SetPoint("TOPLEFT",getglobal(listName.."_Button"..i-1),"BOTTOMLEFT")
	 else
	   button:SetPoint("TOPLEFT",scroller,"TOPLEFT",5,-5)
	 end
	 if (item['onclick'] and strlen(item['onclick']) > 3) then
	 	button:SetScript("OnClick",assert(loadstring(item['onclick'])))
	 end
	 if (item['onenter'] and strlen(item['onenter']) > 3) then
	 	button:SetScript("OnEnter",assert(loadstring(item['onenter'])))
	 end
	 if (item['onleave'] and strlen(item['onleave']) > 3) then
	 	button:SetScript("OnLeave",assert(loadstring(item['onleave'])))
	 end
	 label = button:CreateFontString(button:GetName().."_Text","OVERLAY","GameFontNormalSmall")
	 label:SetAllPoints(button)
	 label:SetWidth(item['width'])
	 label:SetHeight(16)
	 label:SetJustifyH("LEFT")
	 --label:SetText("Button #"..i.." default text")
	 if (item['table'] and item['table'][i]) then
	 	label:SetText(item['table'][i]["title"])
	 end
	 if (i == item.selectedindex) then
	 	label:SetTextColor(1.0, 1.0, 1.0)
	 else
	 	label:SetTextColor(0.8, 0.8, 0.3)
	 end
  end
end

function Loudmouth:GUI_Setup_Easter()
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:GUI_Setup_Easter();");
  local tabname = self:GUI_Get_Tab_Index("Easter_Eggs")
  local frame = self.Tabs[tabname]["framelink"]
  local basePath = self.Tabs[tabname]["frame"]
  local button, checkbox, dropdown, editbox, index, label, slider, table

  frame:Hide()
  frame:SetAllPoints(LMFrame)

  self:GUI_Setup_Elements("Easter_Eggs")
end

function Loudmouth:GUI_Setup_Edit()
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:GUI_Setup_Edit();");
  local tabname = self:GUI_Get_Tab_Index("Edit")
  local frame = self.Tabs[tabname]["framelink"]
  local basePath = self.Tabs[tabname]["frame"]
  local button, checkbox, dropdown, editbox, index, label, slider, table

  frame:Hide()
  frame:SetAllPoints(LMFrame)

  self:GUI_Setup_Elements("Edit")
end

function Loudmouth:GUI_Setup_Elements(frameName)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:GUI_Setup_Elements(",frameName,");");
  local tabname = self:GUI_Get_Tab_Index(frameName)
  local frame = self.Tabs[tabname]["framelink"]
  local basePath = self.Tabs[tabname]["frame"]
  local button, checkbox, dropdown, editbox, index, label, listbox, slider, table

  self:CustomLevelDebug(1,1,1,0,Loudmouth.dataFrame,nil,"Setup_Elements("..frameName..")")
  for index, table in pairs(self.UI.dropdowns) do
    if (self.UI.dropdowns[index]["frame"] and self.UI.dropdowns[index]["frame"] == frameName) then
	 local item = self.UI.dropdowns[index]
	   self:CustomLevelDebug(1,1,1,0,Loudmouth.dataFrame,nil,"Creating "..basePath..item["index"])
		Loudmouth:GUI_CreateDropDownMenu(basePath..item["index"], getglobal(basePath), item)
		if item["updateGUI"] then
			Loudmouth.GUI_Update[(#Loudmouth.GUI_Update+1)] = item["updateGUI"]
		end
		if (item['label'] and strlen(item['label']) > 3) then
  			label = frame:CreateFontString(basePath, "OVERLAY", item.font or "GameFontNormal")
  			label:SetPoint("BOTTOMLEFT", basePath..item.index, "TOPLEFT", 0, 5)
  			label:SetPoint("BOTTOMRIGHT", basePath..item.index, "TOPRIGHT", 0, 5)
  			label:SetText(item.label)
  			label:SetJustifyH(item.justifyH or "CENTER")
		end
	 end
  end
  for index, table in pairs(self.UI.buttons) do
    if (self.UI.buttons[index]["frame"] and self.UI.buttons[index]["frame"] == frameName) then
	 	local item = self.UI.buttons[index]
	   self:CustomLevelDebug(1,1,1,0,Loudmouth.dataFrame,nil,"Creating "..basePath..item["index"])
	 	button = CreateFrame("Button",basePath..item["index"].."_Button",frame,"GameMenuButtonTemplate")
		if (item["hide"]) then
			button:Hide()
			button:Disable()
		end
		button:SetText(item["text"])
		button:SetWidth(item["width"])
		button:SetPoint(item["point"],basePath..item["relativeTo"],item["relativePoint"], item["offsetX"], item["offsetY"])
		if (item['binding']) then
			SetBinding(item['binding'],"CLICK LMFrame_"..frameName..index.."_Button:LeftButton")
		end
		if (item['onclick']) then
	 		button:SetScript("OnClick",assert(loadstring(item['onclick'])))
		end
		if item["updateGUI"] then
			Loudmouth.GUI_Update[(#Loudmouth.GUI_Update+1)] = item["updateGUI"]
		end
		if item["disable"] then
		  button:Disable()
		end
	 end
  end
  for index, table in pairs(self.UI.checkboxes) do
    if (self.UI.checkboxes[index]["frame"] and self.UI.checkboxes[index]["frame"] == frameName) then
	 	local item = self.UI.checkboxes[index]
	   self:CustomLevelDebug(1,1,1,0,Loudmouth.dataFrame,nil,"Creating "..basePath..item["index"])
	 	checkbox = CreateFrame("CheckButton",basePath..item["index"].."_CheckBox",frame,"OptionsCheckButtonTemplate")
		checkbox:SetPoint(item["point"],basePath..item["relativeTo"],item["relativePoint"], item["offsetX"], item["offsetY"])
		checkbox:SetChecked(item["checked"])
		if item["disable"] then
		  checkbox:Disable()
		end
		if item["updateGUI"] then
			Loudmouth.GUI_Update[(#Loudmouth.GUI_Update+1)] = item["updateGUI"]
		end
	 	checkbox:SetScript("OnClick",assert(loadstring(item['onclick'])))
		if (item['label'] and strlen(item['label']) > 2) then
  			label = frame:CreateFontString(basePath, "OVERLAY", item.font or "GameFontNormal")
			local labelpos
			if (item.labelSide == "TOP") then labelpos = "BOTTOM" end
			if (item.labelSide == "LEFT") then labelpos = "RIGHT" end
			if (item.labelSide == "BOTTOM") then labelpos = "TOP" end
			if (item.labelSide == "RIGHT") then labelpos = "LEFT" end
  			label:SetPoint(labelpos, basePath..item.index.."_CheckBox", item.labelSide, 0, 0)
  			label:SetText(item.label)
  			label:SetJustifyH(item.justifyH or "CENTER")
		end
	 end
  end
  for index,table in pairs(self.UI.listboxes) do
  	if (self.UI.listboxes[index]["frame"] and self.UI.listboxes[index]["frame"] == frameName) then
	 	local item = self.UI.listboxes[index]
	   self:CustomLevelDebug(1,1,1,0,Loudmouth.dataFrame,nil,"Creating "..basePath..item["index"])
	 	listbox = CreateFrame("Frame",basePath..item["index"],frame)
		listbox:SetWidth(item["width"]-16)
		listbox:SetHeight((item["rows"]*16)+10)
		listbox:EnableMouseWheel()
		listbox:SetPoint(item["point"],basePath..item["relativeTo"],item["relativePoint"], item["offsetX"], item["offsetY"])
  		listbox:SetBackdrop({edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tileSize=16, edgeSize=16})
	 	--listbox:SetScript("OnVerticalScroll",function()
			--local scrollbar = getglobal(this:GetName().."_ScrollBar")
			--local val = scrollbar:GetValue()
			--local min,max = scrollbar:GetMinMaxValues();
			--if arg1 == min then 
				--getglobal(scrollbar:GetName().."_ScrollUpButton"):Disable();
			--else
				--getglobal(scrollbar:GetName().."_ScrollUpButton"):Enable();
			--end
			--if arg1 == max then 
				--getglobal(scrollbar:GetName().."_ScrollDownButton"):Disable();
			--else
				--getglobal(scrollbar:GetName().."_ScrollDownButton"):Enable();
			--end
			--Loudmouth:GUI_Update_ListBox(this)
		--end)
  		self:GUI_Build_ListBox(listbox:GetName(),item)
		if item["updateGUI"] then
			Loudmouth.GUI_Update[(#Loudmouth.GUI_Update+1)] = item["updateGUI"]
		end
		if (item['label'] and strlen(item['label']) > 3) then
  			label = frame:CreateFontString(basePath, "OVERLAY", item.font or "GameFontNormal")
  			label:SetPoint("BOTTOMLEFT", basePath..item.index, "TOPLEFT", 0, 5)
  			label:SetPoint("BOTTOMRIGHT", basePath..item.index, "TOPRIGHT", 0, 5)
  			label:SetText(item.label)
  			label:SetJustifyH(item.justifyH or "CENTER")
		end
	end
  end
  for index, table in pairs(self.UI.labels) do
    if (self.UI.labels[index]["frame"] and self.UI.labels[index]["frame"] == frameName) then
	 	local item = self.UI.labels[index]
	   self:CustomLevelDebug(1,1,1,0,Loudmouth.dataFrame,nil,"Creating "..basePath..item["index"].." with font "..item["font"])
		if item["updateGUI"] then
			Loudmouth.GUI_Update[(#Loudmouth.GUI_Update+1)] = item["updateGUI"]
		end
		if not item.parent then
  			label = frame:CreateFontString(basePath, "OVERLAY", item.font or "GameFontNormal")
		else
  			label = getglobal(item.parent):CreateFontString(basePath, "OVERLAY", item.font or "GameFontNormal")
		end
  		label:SetPoint(item.point or "TOPLEFT", basePath..(item.relativeTo or ""), item.relativePoint or "TOPLEFT", item.offsetX or 0, item.offsetY or 0)
  		label:SetText(item.text)
  		label:SetJustifyH(item.justifyH or "CENTER")
	 end
  end
end

function Loudmouth:GUI_Setup_Frames()
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:GUI_Setup_Frames();");
  local button, frame, i, prevtabname, tabname

  for i = 1, #self.Tabs do
    tabname = "LMFrameTab"..i
	 prevtabname = "LMFrameTab"..(i-1)
	 button = CreateFrame("Button",tabname,LMFrame,"LM_Tab_Template")
    self.Tabs[i]["tablink"] = button
	 if (i > 1) then
    	button:SetPoint("RIGHT",prevtabname,"LEFT",10,0)
	 else
    	button:SetPoint("BOTTOMRIGHT",-7,-30)
	 end
    --button:SetText(self.Tabs[i]["text"])
    button:SetText(string.gsub(self.Tabs[i]["text"],"_"," "))
    button:SetID(i)
	 if (not getglobal(self.Tabs[i]["frame"])) then
	   frame = CreateFrame("Frame",self.Tabs[i]["frame"],LMFrame)
      self.Tabs[i]["framelink"] = frame
	 end
	 --if (i > 1) then
    --self:GUI_Setup_Elements(self.Tabs[i]["text"])
	 --end
	 if (strlen(self.Tabs[i]["init"]) > 3) then
	 	assert(loadstring(self.Tabs[i]["init"])) ()
	 end
  end
  self.Tabs[1]["framelink"] = getglobal("LMFrame_Quote")
end

function Loudmouth:GUI_Setup_Help()
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:GUI_Setup_Help();");
  local tabname = self:GUI_Get_Tab_Index("Help")
  local frame = self.Tabs[tabname]["framelink"]
  local basePath = self.Tabs[tabname]["frame"]
  local button, childFrame, i, label, scroller, texture

  label = frame:CreateFontString(basePath.."_Label","OVERLAY","GameFontNormalLarge")
  frame:Hide()
  frame:SetAllPoints(LMFrame)
  self:GUI_Setup_Elements("Help")

  scroller=CreateFrame("ScrollFrame",basePath.."_TopicText",frame,UIPanelScrollFrameTemplate)
  scroller:SetWidth(340)
  scroller:SetHeight(330)
  scroller:SetBackdrop({edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tileSize=16, edgeSize=16})
  scroller:SetPoint("TOPRIGHT",frame,"TOPRIGHT",-20,-70)
  scroller:EnableMouseWheel()
  label = scroller:CreateFontString(basePath.."_Label","OVERLAY","GameFontNormalSmall")
  label:SetText("Topic Text")
  label:SetPoint("TOP",scroller,"TOP",0,12)

  childFrame=CreateFrame("Frame",basePath.."_TopicText_ScrollChild",scroller)
  scroller:SetScrollChild(childFrame)
  childFrame:SetWidth(300)
  childFrame:SetHeight(325)
  childFrame:SetBackdrop({bgFile = "Interface/Stationery/AuctionStationery1", tileSize=16, edgeSize=16})
  --childFrame:SetBackdrop({bgFile = "Interface/AddOns/Loudmouth/Stationery", tileSize=16, edgeSize=16})
  childFrame:SetAllPoints(scroller)
  label = childFrame:CreateFontString(basePath.."_TopicText_ScrollChild_Title","OVERLAY","QuestTitleFont")
  label:SetPoint("TOPLEFT",childFrame,"TOPLEFT",35,-20)
  label:SetText(Loudmouth.help[1]["title"])
  label = childFrame:CreateFontString(basePath.."_TopicText_ScrollChild_Text", "OVERLAY", "QuestFont")
  label:SetPoint("TOPLEFT", getglobal("LMFrame_Help_TopicText_ScrollChild_Title"), "BOTTOMLEFT", 0, 0)
  label:SetJustifyH("LEFT")
  label:SetWidth(300)
  label:SetText(Loudmouth.help[1]["detail"])
  scroller:UpdateScrollChildRect()
  scroller:EnableMouseWheel()
  --getglobal(scroller:GetName().."ScrollBar"):SetValue(0)
  --getglobal(frame:GetName().."_TopicList_Button1"):Click()

end

function Loudmouth:GUI_Setup_Options()
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:GUI_Setup_Options();");
  local tabname = self:GUI_Get_Tab_Index("Options")
  local frame = self.Tabs[tabname]["framelink"]
  local basePath = self.Tabs[tabname]["frame"]
  local button, checkbox, dropdown, editbox, index, label, slider, table

  frame:Hide()
  frame:SetAllPoints(LMFrame)

  --checkbox = CreateFrame("CheckButton", basePath.."_Debug",frame,"OptionsCheckButtonTemplate")
  --checkbox:SetPoint("BOTTOMRIGHT",frame,"BOTTOMRIGHT",-20,20)
  --checkbox:SetScript("OnClick", function()
    --self:GUI_Check_Click(this)
	 --self:Update_GUI_Data()
  --end)
  editbox = CreateFrame("EditBox",basePath.."_Set_AddName",frame,"InputBoxTemplate")
  editbox:SetPoint("TOPLEFT", frame, "TOPLEFT", 20, -70)
  editbox:SetAutoFocus(0)
  editbox:Show()
  editbox:SetBackdropColor(0,0,0,1)
  editbox:SetWidth(90)
  editbox:SetHeight(20)

  self:GUI_Setup_Elements("Options")
  slider = CreateFrame("Slider",basePath.."_Wisecrack",frame,"LM_Rate_Template")
  slider:SetPoint("TOPRIGHT",frame,"TOPRIGHT",-20,-70)
  getglobal(slider:GetName().."_Label"):SetText("Wisecrack Cooldown")
  getglobal(slider:GetName().."_Label"):ClearAllPoints()
  getglobal(slider:GetName().."_Label"):SetPoint("BOTTOM",slider:GetName(),"TOP",-20,0)
  getglobal(slider:GetName().."_Slider"):SetValueStep(5)
  getglobal(slider:GetName().."_Slider"):SetMinMaxValues(5,300)
  getglobal(slider:GetName().."_Slider"):SetValue(self:Get_Rate("Wisecrack"))
  getglobal(slider:GetName().."_SliderLow"):SetText("5")
  getglobal(slider:GetName().."_SliderHigh"):SetText("300")

--Loudmouth.Channels = { "UI", "Say", "Party", "Raid", "Guild", "Officer" }
end

--
-- Loudmouth UI handlers
--

function Loudmouth:GUI_Check_Click(box)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:GUI_Check_Click(",box:GetName(),");");
  if (box:GetName() == "LMEditFrame_Emote") then	
	 if (self.editing_item ~= 0) then
      self.db.profile.quotes[self.edit_set_name][self.edit_event_name][self.editing_item]["emote"]=box:GetChecked()
	 end
  elseif (box:GetName() == "LMFrame_Quote_Enable") then
    self:Set_Event_State(self.edit_event_name,box:GetChecked())
  elseif (box:GetName() == "LMFrame_Edit_Enable_CheckBox") then
    self:Set_Event_State(self.UI.dropdowns["_EditEvent"].table[self.UI.dropdowns["_EditEvent"].selected],box:GetChecked())
  elseif (box:GetName() == "LMFrame_Options_Debugging_CheckBox") then
    if (box:GetChecked() == 1) then
      self.db.profile.Debug = 1
	 else
      self.db.profile.Debug = 0
	 end
    self:SetDebugging(self.db.profile.Debug == 1)
	 --self:Print("Debug: now "..self.db.profile.Debug)
  else
  	self:CustomLevelDebug(1,1,1,0,Loudmouth.dataFrame,nil,"Unknown Checkbox: "..this:GetName())
  end
  self:Update_GUI_Data()
end

function Loudmouth:GUI_CreateDropDownMenu(myName, parent, options)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:GUI_CreateDropDownMenu(",myName,",",parent:GetName(),",",options,");");
  local f = CreateFrame("Frame", myName, parent)
  f.children = {}
  f:SetWidth(options.width or 80)
  f:SetHeight(22)
  f:SetPoint(options["point"] or "TOPLEFT", "LMFrame_"..options["frame"]..options["relativeTo"], options["relativePoint"] or "TOPLEFT", options["offsetX"] or 0, options["offsetY"] or 0)
  f:SetBackdrop( {
    bgFile = "Interface/Tooltips/UI-Tooltip-Background", tile = true,
	 tileSize = 16, edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
	 edgeSize = 10, inserts = { left=3, right=3, top=3, bottom=3},
  })
  f:SetBackdropBorderColor(0.5, 0.5, 0.5)
  f:SetBackdropColor(0,0,0,1)
  f.selection = f:CreateFontString(myName.."_Text", "BACKGROUND")
  f.selection:SetWidth(f:GetWidth() - 22)
  f.selection:SetHeight(16)
  f.selection:SetFontObject(GameFontHighlightSmall)
  f.selection:SetPoint("RIGHT",f,"RIGHT",-22,0)
  f.selection:SetJustifyH(options.justify or "RIGHT")
  f.selection:SetText(options.table[options.selected])
  f.button = CreateFrame("Button", myName.."_Button", f)
  f.button:SetWidth(20)
  f.button:SetHeight(20)
  f.button:SetPoint("RIGHT",f,"RIGHT",-1,0)
  f.button:SetNormalTexture("Interface/ChatFrame/UI-ChatIcon-ScrollDown-Up")
  f.button:SetPushedTexture("Interface/ChatFrame/UI-ChatIcon-ScrollDown-Down")
  f.button:SetDisabledTexture("Interface/ChatFrame/UI-ChatIcon-ScrollDown-Disabled")
  f.button.highlightTexture = f.button:CreateTexture()
  f.button.highlightTexture:SetTexture("Interface/Buttons/UI-Common-MouseHilight")
  f.button.highlightTexture:SetBlendMode("ADD")
  f.button.highlightTexture:SetAllPoints(f.button)
  f.button:SetHighlightTexture(f.button.highlightTexture)
  f.button:SetScript("OnHide", function() dewdrop:Close() end)
  f.button:SetScript("OnClick", function()
  		PlaySound("igMainMenuOptionsCheckBoxOn")
		if dewdrop:IsOpen(f) then
			dewdrop:Close()
		else
			dewdrop:Open(f,'point',"TOPRIGHT",'relativePoint',"BOTTOMRIGHT",'children',function()
				for i = 1, #options.table do
					dewdrop:AddLine(
						'text', options.table[i],
						'func', function (o, i)
							--f.value = o.table[i]
							f.selection:SetText(o.table[i])
							o.selected = i
							if (o.func) then
	 							assert(loadstring(o.func)) ()
							end
  							self:Update_GUI_Data()
							dewdrop:Close()
						end,
						'arg1', options,
							--options:GetName(),
						'arg2', i,
						'isRadio', true,
						'checked', options.selected == i
					)
				end
			end)
		end
  end)

  return f
end

function Loudmouth:GUI_DropDown_Initialize()
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:GUI_DropDown_Initialize(",");");
  local info, index, value, key;

  for index, value in pairs(self.UI.dropdowns) do
   if (this:GetName() == "LMFrame_Options"..value.index.."Button" or
	    this:GetName() == "LMFrame_Options"..value.index) then
		 self:Print("Init value.index = "..value.index)
		 self:Print("this:GetName() is "..this:GetName())
			local label = getglobal("LMFrame_Options"..value.index.."_Label")
			if (strlen(value["label"]) >= 2) then
			   --self:Print("Label is "..value["label"])
				label:SetText(value.label)
			end
			self:Print("Options list is "..#value["table"].." items long.")
			for key = 1, #value["table"] do
				info = UIDropDownMenu_CreateInfo()
				info.text = value["table"][key]
				--self:Print("indexed text is "..info.text)
				info.func = function(x,y) Loudmouth:GUI_DropDown_OnClick(x,y) end
				info.arg1 = value.index
				info.arg2 = value.frame
				info.owner = getglobal("LMFrame_"..value.frame..value.index)
				UIDropDownMenu_AddButton(info)
			end
			UIDropDownMenu_SetSelectedID(getglobal("LMFrame_Options"..value["index"]), value["selected"])
	end
  	if (this:GetName() == "LMFrame_Quote"..value.index.."Button" or
  	    this:GetName() == "LMFrame_Quote"..value.index) then
		local label = getglobal("LMFrame_Quote"..index.."_Label")
		if (strlen(value.label) >= 2) then
			label:SetText(value.label)
		end
		for key = 1, #value.table do
			info = UIDropDownMenu_CreateInfo()
			if (self.db.profile) then
				if (key == self.db.profile[index])
				then	info.checked = true
				else	info.checked = nil
				end
			end
			info.text = value.table[key]
			info.func = function(x,y) self:GUI_DropDown_OnClick(x,y) end
			info.arg1 = value.index
			info.arg2 = "Quote"
			UIDropDownMenu_AddButton(info)
		end
		if (string.find(this:GetName(),"_SendQuote")) then	
			local name,number
			for k = 1, 10  do
			   number,name = GetChannelName(k)
				if (name ~= nil) then
					info = UIDropDownMenu_CreateInfo()
					info.text = name
					info.value = k
					info.func = function(x,y) self:GUI_DropDown_OnClick(x,y) end
					info.arg1 = value.index
					info.arg2 = "Quote"
					UIDropDownMenu_AddButton(info)
				end
			end
		end
		break;
	end
	UIDropDownMenu_SetSelectedID(this, this:GetID())
  end
end

function Loudmouth:GUI_DropDown_OnClick(list,frame)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:GUI_DropDown_OnClick(",list,",",frame,");");
  if not frame then
    frame = "Quote"
  end

  --self:Print("List: "..list.." frame = "..frame)
  local ddl = getglobal("LMFrame_"..frame..list)
  UIDropDownMenu_SetSelectedID(ddl, this:GetID())
  local selected = UIDropDownMenu_GetSelectedValue("LMFrame_"..frame..list)
  --self:Print("List: "..list.." frame = "..frame)
  --self:Print("this:GetName() = "..this:GetParent():GetName())
  --self:Print("UIDropDownMenu_GetSelectedID(this) = "..UIDropDownMenu_GetSelectedID(this:GetParent()))
  if (list == "_SendQuote")
  then	local channel = this:GetText()
  			if (this:GetID() ~= 1)
			then
				if (this:GetID() > #self.UI.dropdowns["_SendQuote"].table)
				then
					SendChatMessage(LMFrame_Quote_QuoteEdit:GetText(),"CHANNEL",nil,GetChannelName(channel))
				else
  					SendChatMessage(LMFrame_Quote_QuoteEdit:GetText(),channel)
				end
    			UIDropDownMenu_ClearAll(LMFrame_Quote_SendQuote)
    			UIDropDownMenu_SetSelectedID(LMFrame_Quote_SendQuote,1)
			end
  			return
  end
  if (list == "_QuoteSet") then
  		self.UI.dropdowns["_QuoteSet"].selected=UIDropDownMenu_GetSelectedID(this)
		Loudmouth:Update_GUI_Data()
  end

  if (not self.db.profile[list] and self.UI.dropdowns[list]) then
    self:Print("Dropdown "..list.." selected is now #"..this:GetID())
  elseif (this:GetID() ~= self.db.profile[list]) then
   --if (list == "_QuoteSet") then
	  --if (this:GetText() ~= "Char" and this:GetText() ~= "Class") then
	    --self.db.profile.ActiveSet = this:GetText()
	  --end
	--end
  	self.db.profile[list] = this:GetID()
	self:GUI_Input_Disable()
   LMFrame_Quote_QuoteEdit:ClearFocus()
	self:Auto_Vars()
  	self:GUI_ListBox_OnShow("LMFrame_Quote"..list)

  else
    self.db.profile[list] = this:GetID()
  end
  self:Update_GUI_Data()
end

function Loudmouth:GUI_DropDown_OnShow(element)
  local elementname = ""
  if (element ~= nil) then elementname = element:GetName(); end
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:GUI_DropDown_OnShow(",elementname,");");
  --if not element then
    --element = this
  --end
  local thisFrame = string.sub(this:GetName(),strlen("LMFrame")+1)
  local frameIndex = string.find(thisFrame,"_",2)-1
  local frameName = string.sub(thisFrame,2,frameIndex)
  local listIndex = string.find(thisFrame,"_",frameIndex+1)-1
  local listName = string.sub(thisFrame,frameIndex+1)

  --self:Print("Showing "..element)
  --self:GUI_DropDown_Initialize(element)
  if (listName == "_QuoteSet") then
    UIDropDownMenu_SetSelectedName(this,self.edit_set_name)
    UIDropDownMenu_SetWidth(80,LMFrame_Quote_QuoteSet)
  end
  if (listName == "_QuoteEvent") then
  	 UIDropDownMenu_SetSelectedName(this,self.edit_event_name)
    UIDropDownMenu_SetWidth(80,LMFrame_Quote_QuoteEvent)
	 LMFrame_Quote_QuoteEvent:ClearAllPoints()
	 LMFrame_Quote_QuoteEvent:SetPoint("LEFT",LMFrame_Quote_QuoteSet,"RIGHT", 5, 0)
  end
  if (listName == "_SendQuote") then
    UIDropDownMenu_SetSelectedID(LMFrame_Quote_SendQuote,1)
  end
  if (listName == "_SetList") then
    UIDropDownMenu_SetSelectedID(LMFrame_Options_SetList,1)
  end
  if (listName == "_Babble") then
    --UIDropDownMenu_SetSelectedID(LMFrame_Options_Babble,1)
    UIDropDownMenu_SetSelectedName(LMFrame_Options_Babble,self.db.profile.Channel)
  end
  if (listName == "_EditSet") then
    UIDropDownMenu_SetSelectedName(LMFrame_Edit_EditSet,self.edit_set_name)
  end
end

function Loudmouth:GUI_Get_Tab_Index(string)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:GUI_Get_Tab_Index(",string,");");
  for i = 1, #self.Tabs do
    if (self.Tabs[i]["text"] == string) then 
	   return i
	 end
  end
  return false
end

function Loudmouth:GUI_Input_Disable(keepfocus)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:GUI_Input_Disable(",keepfocus,");");
  if not keepfocus then
    keepfocus = 0
    --LMFrame_Quote_QuoteEdit:ClearFocus()
  --else
    --LMFrame_Quote_QuoteEdit:SetFocus()
  end

  --self:Print("InputDisable(Keepfocus) = "..keepfocus)
  --if (keepfocus ~= 1) then
    --LMFrame_Quote_QuoteEdit:ClearFocus()
  --end
  LMFrame_Quote_QuoteEdit:SetText("")
  LMFrame_Quote_QuoteList_Highlight:Hide()
  self.editing_item = 0
  LMFrame_Quote_NumCharsLeft:SetText("")
  LMFrame_Quote_NumCharsLeft:Hide()
  LMFrame_Quote_CharsLeft:Hide()
  LMFrame_Quote_ButtonDelete:Hide()
  LMFrame_Quote_ButtonCancel:Hide()
  LMFrame_Quote_ButtonSave:Hide()
  LMFrame_Quote_SendQuote:Hide()
  LMEditFrame_Emote:SetChecked(0)
  LMEditFrame:Hide()
end

function Loudmouth:GUI_Input_Enable()
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:GUI_Input_Enable(",");");
  LMFrame_Quote_ButtonCancel:Show()
  LMFrame_Quote_ButtonSave:Show()
  LMFrame_Quote_NumCharsLeft:Show()
  LMFrame_Quote_CharsLeft:Show()
  if (self.editing_item ~= 0) then
    LMFrame_Quote_ButtonSave:SetText("Update")
	 LMFrame_Quote_ButtonCancel:SetText("Cancel Update")
    LMFrame_Quote_ButtonDelete:Show()
  else
    LMFrame_Quote_ButtonSave:SetText("Add")
	 LMFrame_Quote_ButtonCancel:SetText("Cancel Add")
  end
  LMEditFrame:Show()
  LMFrame_Quote_SendQuote:Show()
end

function Loudmouth:GUI_ListBox_OnScroll(box)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:GUI_ListBox_OnScroll(",box:GetName(),");");
  if (Loudmouth:GUI_Get_UI_Data(box).item) then
  		Loudmouth:GUI_Update_ListBox(box)
  end
  --self:Auto_Vars()
  local scrollbar = LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar
  local buttonNo = 1
  local n = scrollbar:GetValue() - 1

  for i = 1, 15, 1 do
    getglobal("LMFrame_Quote_QuoteList_Button"..i.."_Text"):SetText("");
  end

  local temp = self.editing_item - n
  if temp <= 0 or temp >= 16 then
    LMFrame_Quote_QuoteList_Highlight:Hide();
  else
    local highlight = LMFrame_Quote_QuoteList_Highlight;
    highlight:Show();
    highlight:ClearAllPoints();
    highlight:SetPoint("TOPLEFT", "LMFrame_Quote_QuoteList_Button"..temp, "TOPLEFT", 0, 0);
  end

  --self:GUI_ListBox_OnShow()
  LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar_ScrollUpButton:Disable()
  --for key = 1, #quotelist do
  for key = 1, #editlist do
    --value = quotelist[key]["quote"]
    value = editlist[key]["quote"]
    if n == 0 then
	   if (self.current_button_shown ~= 0) then
	  		self:GUI_ListButton_ShowTooltip(getglobal("LMFrame_Quote_QuoteList_Button"..self.current_button_shown))
	   end
      if buttonNo == 16 then
        LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar_ScrollDownButton:Enable();
		  return
      end
      getglobal("LMFrame_Quote_QuoteList_Button"..buttonNo.."_Text"):SetText(value);
      buttonNo = buttonNo + 1;
    else
      n = n - 1;
		LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar_ScrollUpButton:Enable()
    end
  end
  LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar_ScrollDownButton:Disable()
  if (self.current_button_shown ~= 0) then
	 self:GUI_ListButton_ShowTooltip(getglobal("LMFrame_Quote_QuoteList_Button"..self.current_button_shown))
  end
end

function Loudmouth:GUI_ListBox_OnShow(offset)
  --self:Auto_Vars()
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:GUI_ListBox_OnShow(",offset,");");
  local i = 4;
  local scrollsteps = self.current_num_quotes-14
  if (scrollsteps < 1) then scrollsteps = 1 end
  if (not offset) then
    offset = 1
  end

  LMFrame_Quote_QuoteList:EnableMouseWheel(true)
  LMFrame_Quote_QuoteList:SetScript("OnMouseWheel", function()
  	if arg1 > 0 then LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar_ScrollUpButton:Click() 
	elseif arg1 < 0 then LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar_ScrollDownButton:Click()
	end
  end)
  for i = 1, 15 do
    getglobal("LMFrame_Quote_QuoteList_Button"..i.."_Text"):SetText("")
    getglobal("LMFrame_Quote_QuoteList_Button"..i..""):Hide()
  end
  LMFrame_Quote_QuoteList_ScrollFrame:Hide()
  LMFrame_Quote_QuoteList_Label:SetText(L["Quote List"].." - "..self.current_num_quotes.." "..L["quotes"]);
  --for i = 1, #quotelist
  for i = 1, #editlist
  do
	if (i <= 15)
	--then	getglobal("LMFrame_Quote_QuoteList_Button"..i.."_Text"):SetText(quotelist[i]["quote"])
	then	getglobal("LMFrame_Quote_QuoteList_Button"..i.."_Text"):SetText(editlist[i]["quote"])
    		getglobal("LMFrame_Quote_QuoteList_Button"..i):Show()
	else	LMFrame_Quote_QuoteList_ScrollFrame:Show()
	end
  end
  LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar:SetMinMaxValues(1,scrollsteps)
  LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar:SetValue(1)
  LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar_ScrollUpButton:Disable()
  if (scrollsteps > 1)
  then	LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar_ScrollDownButton:Enable()
  else	LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar_ScrollDownButton:Disable()
  end
end

function Loudmouth:GUI_ListButton_OnClick(button)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:GUI_ListBox_OnClick(",button:GetName(),");");
  self:Auto_Vars()
  if (self.UI.dropdowns["_EditSet"].selected == 1) then
  	return
  end
  local listnum=tonumber(strsub(button:GetName(),strfind(button:GetName(),"n",-3)+1))
  local quotenum=listnum+LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar:GetValue()-1
  --if (quotenum <= #quotelist)
  if (quotenum <= #editlist)
  then
    self.editing_item=quotenum
    LMFrame_Quote_QuoteEdit:SetText(getglobal(button:GetName().."_Text"):GetText())
	 --LMEditFrame_Emote:SetChecked(quotelist[self.editing_item]["emote"])
	 LMEditFrame_Emote:SetChecked(editlist[self.editing_item]["emote"])
    LMFrame_Quote_QuoteList_Highlight:Show()
    LMFrame_Quote_QuoteList_Highlight:ClearAllPoints()
    LMFrame_Quote_QuoteList_Highlight:SetPoint("TOPLEFT",button:GetName(), "TOPLEFT", 0, 0)
	 LMFrame_Quote_QuoteEdit:SetFocus()
	 LMFrame_Quote_QuoteEdit:HighlightText(strlen(LMFrame_Quote_QuoteEdit:GetText()))
  else
    self:Print("Not editing that quote, it's blank.");
  end
end

function Loudmouth:GUI_ListButton_HideTooltip(button)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:GUI_ListButton_HideTooltip(",button:GetName(),");");
  GameTooltip:Hide()
  self.current_button_shown = 0
end

function Loudmouth:GUI_ListButton_ShowTooltip(button)
  --self:Auto_Vars()
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:GUI_ListButton_ShowTooltip(",button:GetName(),");");
  local boxwidth, textwidth
  local thisquote
  local listnum=tonumber(strsub(button:GetName(),strfind(button:GetName(),"n",-3)+1))
  local quotenum=listnum+LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar:GetValue()-1
  local quoteopts = self:Quote_Has_Options(quotenum)

  LMFrame_Quote_Temp_String_Text:SetText(getglobal(button:GetName().."_Text"):GetText())
  boxwidth = getglobal(button:GetName().."_Text"):GetStringWidth()
  textwidth = LMFrame_Quote_Temp_String_Text:GetWidth()

  if (textwidth > boxwidth or quoteopts == true or self.edit_set_name == 'All')
  then
  		self.current_button_shown = listnum
      thisquote = getglobal(button:GetName().."_Text"):GetText()
		--if (quotelist[quotenum]["emote"] == 1) then
		if (editlist[quotenum]["emote"] == 1) then
		  thisquote = "/me "..thisquote
		end
  		GameTooltip:SetOwner(button,"ANCHOR_TOPLEFT")
  		--GameTooltip:AddLine("Quote: (set "..quotelist[quotenum]["setName"]..")",  1.0, 1.0, 1.0, 1.0, 0)
  		GameTooltip:AddLine("Quote: (set "..editlist[quotenum]["setName"]..")",  1.0, 1.0, 1.0, 1.0, 0)
		GameTooltip:AddLine(thisquote, 0.3, 0.8, 1.0, 1.0, 1)
		if (quoteopts) then
  		  GameTooltip:AddLine("Options:",  1.0, 1.0, 1.0, 1.0, 0)
		end
		--if (quotelist[quotenum]["emote"] == 1) then
		if (editlist[quotenum]["emote"] == 1) then
		  GameTooltip:AddLine("Emote", 0.3, 0.8, 1.0, 1.0, 1)
		end
		GameTooltip:Show()
  end
end

function Loudmouth:GUI_Quote_Edit_Updating()
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:GUI_Quote_Edit_Updating(",");");
  if (strlen(LMFrame_Quote_QuoteEdit:GetText()) >= 1) then	
  	if (self.editing_item == 0 and self.edit_set_name == "All") then
		self:GUI_Input_Disable()
	else
  		self:GUI_Input_Enable()
  		LMFrame_Quote_NumCharsLeft:SetText((255-strlen(LMFrame_Quote_QuoteEdit:GetText())))
	end
  else	
  	self:GUI_Input_Disable()
  end
end

function Loudmouth:GUI_Rate_Edit_Changed(Box)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:GUI_Rate_Edit_Changed(",box:GetName(),");");
  if (Box == nil) then return end

  if (Box:GetName() == "LMFrame_Quote_Rate_EditBox") then
    self:Set_Rate(self.edit_event_name, tonumber(Box:GetText()))
    getglobal(Box:GetParent():GetName().."_Slider"):SetValue(tonumber(Box:GetText()))
  end

  if (Box:GetName() == "LMFrame_Options_Wisecrack_EditBox") then
    self:Set_Rate("Wisecrack", tonumber(Box:GetText()))
	 getglobal(Box:GetParent():GetName().."_Slider"):SetValue(tonumber(Box:GetText()))
  end

  self:Update_GUI_Data()
end

function Loudmouth:GUI_Rate_Show()
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:GUI_Rate_Show(",");");
  if (self.edit_event_name == "Excuses" or
      self.edit_event_name == "AFK")
  then	LMFrame_Quote_Rate:Hide()
  			LMFrame_Quote_Enable:Show()
			LMFrame_Quote_Enable:SetChecked(self:Get_Event_State())
  else	
			if (self:Get_Event_State()==1)
			then	LMFrame_Quote_Rate:Show()
			else	LMFrame_Quote_Rate:Hide()
			end
  			LMFrame_Quote_Enable:Show()
  			LMFrame_Quote_Rate_Label:SetText(self.edit_event_name..L[" Rate     Slider    Value  "])
			LMFrame_Quote_Enable:SetChecked(self:Get_Event_State())
  			LMFrame_Quote_Rate_EditBox:SetText(self:Get_Rate())
  			LMFrame_Quote_Rate_Slider:SetValue(self:Get_Rate())
  end
  LMFrame_Options_Wisecrack_Slider:SetValue(self:Get_Rate("Wisecrack"))
end

function Loudmouth:GUI_Rate_Slider_Changed(Slider)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:GUI_Rate_Slider_Changed(",Slider:GetName(),");");
  if (Slider == nil) then return end

  if (Slider:GetName() == "LMFrame_Quote_Rate_Slider") then
    self:Set_Rate(self.edit_event_name, tonumber(Slider:GetValue()))
    getglobal(Slider:GetParent():GetName().."_EditBox"):SetText(tonumber(Slider:GetValue()))
  end
  if (Slider:GetName() == "LMFrame_Options_Wisecrack_Slider") then
    self:Set_Rate("Wisecrack", tonumber(Slider:GetValue()))
    getglobal(Slider:GetParent():GetName().."_EditBox"):SetText(tonumber(Slider:GetValue()))
  end
  --if self.loaded then
    self:Update_GUI_Data()
  --end
end

function Loudmouth:GUI_Show()
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:GUI_Show(",");");
  LMFrame:Show();
end

function Loudmouth:GUI_Tab_OnClick()
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:GUI_Tab_OnClick(",");");
  --local tab = Loudmouth.Tabs[this:GetName()]
  local tab = LMFrame.selectedTab
  local index

  for index = 1, #self.Tabs do
    if (self.Tabs[index]["index"] == tab) then
    	self.Tabs[index]["framelink"]:Show()
	 else
    	self.Tabs[index]["framelink"]:Hide()
	 end
  end
  self:Update_GUI_Data()
end

--
-- Loudmouth Logic code
--

function Loudmouth:Auto_Vars()
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:Auto_Vars(",");");
  self.edit_event_id=self.db.profile["_QuoteEvent"]
  self.edit_event_name=self.UI.dropdowns["_QuoteEvent"].table[self.db.profile["_QuoteEvent"]]
  self.edit_set_name=self.UI.dropdowns["_QuoteSet"].table[self.db.profile["_QuoteSet"]]
  --self:Get_Quote_Event(self.edit_event_name,quotelist,self.edit_set_name)
  self:Get_Quote_Event(self.edit_event_name,editlist,self.edit_set_name)
  --self.current_num_quotes=#quotelist
  self.current_num_quotes=#editlist
  --self.current_total_quotes = self:Num_Quotes()
end

function Loudmouth:BeatTheOdds(rate)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:BeatTheOdds(",rate,");");
  local randomvalue = math.random()

  --self:CustomLevelDebug(1,1,1,1,Loudmouth.dataFrame,nil,"Random: "..randomvalue.." rate: "..rate)
  if (randomvalue <= (rate/100)) then
    return true
  else
    return false
  end
end

function Loudmouth:Choose_Quote_Event(event, outtable, set)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:Choose_Quote_Event(",event,",",outtable,",",set,");");
  local index, item

  if not set then
    set = self.db.profile.ActiveSet
  end
  self:Get_Quote_Event(event,outtable, set)
  if (#outtable >= 1) then
    index = math.random(#outtable)
    while (#outtable > 1 and self.lastQuoteID[event] == index) do
      index = math.random(#outtable)
    end
    for item in pairs(outtable[index]) do
      currentquote[item] = outtable[index][item]
    end
    self.lastQuoteID[event] = index
  end
end

function Loudmouth:Get_Event_State(event)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:Get_Event_State(",event,");");
  if not event then
    event = self.edit_event_name
  end

  if self.db.profile.enabled[event] == true then
    self.db.profile.enabled[event] = 1
  end
  if self.db.profile.enabled[event] == false then
    self.db.profile.enabled[event] = 0
  end

  return self.db.profile.enabled[event]
end

function Loudmouth:Get_Quote_Event(event,outtable,set)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:Get_Quote_Event(",event,",",outtable,",",set,");");
  local all, index, item, offset, table
  local allquotes = self.db.profile.quotes
  local myquotes = self.db.char.quotes
  
  all = false
  offset = 0
  self:Reset_Quote_Vars(outtable)

  if (not set or set == "All") then
    set = self.db.profile.ActiveSet
    all = true
  end

  if (set ~= "Class" and set ~= "Char") then
    if (all) then
	 	for thisset,tables in pairs(allquotes) do
			if (thisset ~= "Class") then
				--self:Print("Fetching event "..event.." in set "..thisset.." ("..#self.db.profile.quotes[thisset][event]..")")
    			for index = 1, #self.db.profile.quotes[thisset][event]
	 			do
      			offset = offset + 1
					outtable[offset] = {}
      			outtable[offset]["quote"] = allquotes[thisset][event][index]["quote"]
	   			outtable[offset]["emote"] = allquotes[thisset][event][index]["emote"]
					outtable[offset]["setName"] = thisset
	 			end
			end
		end
	else
		--self:Print("Fetching event "..event.." in set "..set.." ("..#self.db.profile.quotes[set][event]..")")
    	for index = 1, #self.db.profile.quotes[set][event]
	 	do
      	offset = offset + 1
			outtable[offset] = {}
      	outtable[offset]["quote"] = allquotes[set][event][index]["quote"]
	   	outtable[offset]["emote"] = allquotes[set][event][index]["emote"]
			outtable[offset]["setName"] = set
	 	end
	 end
  end
  if (all or set == "Class") then
    --self:Print("Fetching event "..event.." in class set "..self.className.." ("..#self.db.profile.quotes["Class"][self.className][event]..")")
    for index = 1, #self.db.profile.quotes["Class"][self.className][event]
	 do
		offset = offset + 1
		outtable[offset] = {}
	   outtable[offset]["quote"] = allquotes["Class"][self.className][event][index]["quote"]
		outtable[offset]["emote"] = allquotes["Class"][self.className][event][index]["emote"]
		outtable[offset]["setName"] = "Class"
	 end
  end
  if (all or set == "Char") then
    for index = 1, #self.db.char.quotes[event]
	 do
		offset = offset + 1
		outtable[offset] = {}
	   outtable[offset]["quote"] = myquotes[event][index]["quote"]
		outtable[offset]["emote"] = myquotes[event][index]["emote"]
		outtable[offset]["setName"] = "Char"
	 end
  end
  --if (self.db.profile.Debug) then
    --for index = 1, #quotelist
    --do
  	   --self:CustomLevelDebug("#"..index.." '"..quotelist[index]["quote"].."' Emote: "..quotelist[index]["emote"])
    --end
  --end
end

function Loudmouth:Get_Rate(event)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:Get_Rate(",event,");");
  if not event and self.edit_event_name then
  event = self.edit_event_name
  end

  if event and self.db.profile.rates[event] then
    return self.db.profile.rates[event]
  else
    return nil
  end
end

function Loudmouth:RemoveSet(setName,quoteTable,moduleName)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:RemoveSet(",setName,",",quoteTable,",",moduleName,");");
  local index
  --self:Print("Current Number of quotes..."..self.current_total_quotes)
  self:Print("Removing quote set "..setName.." from module "..moduleName)
  if (self.db.profile.quotes[setName]) then
  	self.db.profile.quotes[setName] = nil
  end
  --index = table_find(self.UI.dropdowns["_EditSet"].table,setName)
  index = table_find(self.Sets,setName)
  if (index) then
  		if (type(index) == "number") then
			--table.remove(self.UI.dropdowns["_EditSet"].table,index)
			table.remove(self.Sets,index)
		else
			--self.UI.dropdowns["_EventSet"].table[index] = nil
			self.Sets[index] = nil
		end
  end
  self:Auto_Vars()
  self.current_total_quotes = self:Num_Quotes()
  self:Update_GUI_Data()
  --self:Print("Current Number of quotes..."..self.current_total_quotes)
end

function Loudmouth:InstallSet(setName,quoteTable,moduleName)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:InstallSet(",setName,",",quoteTable,",",moduleName,");");
  --self:Print("Current Number of quotes..."..self.current_total_quotes)
  self:CustomLevelDebug(1,1,1,0,Loudmouth.dataFrame,nil,"Installing quote set "..setName.." from module "..moduleName)
  if (not self.db.profile.quotes[setName]) then
	 self.Sets[#self.Sets+1] = setName
    --self.UI.dropdowns["_EditSet"].table[#self.UI.dropdowns["_EditSet"].table+1] = setName
    self:Print("Loudmouth: Creating set "..setName)
    self.db.profile.quotes[setName] = {
	 	["AFK"] = {}, ["Crits"] = {}, ["Excuses"] = {}, ["Fears"] = {}, ["Misses"] = {}
	 }
	 local newSet = self.db.profile.quotes[setName]
	 local category, index, newindex
	 for category,_ in pairs(quoteTable) do
	 	--self:Print("Loudmouth-"..setName..": category "..category.." has "..#quoteTable[category].." quotes.")
		for index = 1, #quoteTable[category] do
        newindex = #self.db.profile.quotes[setName][category] + 1
        self.db.profile.quotes[setName][category][newindex] = {}
	     self.db.profile.quotes[setName][category][newindex]["quote"] = quoteTable[category][index]
	     self.db.profile.quotes[setName][category][newindex]["emote"] = 0
		  self.db.profile.quotes[setName][category][newindex]["IsModule"] = true
		end
	 end
  end
  if (self.db.profile.ActiveSet == "All" or self.db.profile.ActiveSet == setName) then
  		self:Auto_Vars()
  end
  self.current_total_quotes = self:Num_Quotes()
  --self:Print("Current Number of quotes..."..self.current_total_quotes)
end

function Loudmouth:Num_Quotes()
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:Num_Quotes(",");");
  local number = 0
  local setidx = ""
  local eventidx = ""
  local classidx = ""

  setidx = next(self.db.profile.quotes, nil)
  while (setidx ~= nil)
  do
    if (setidx ~= "Class") then
  	 	eventidx = next(self.db.profile.quotes[setidx], nil)
	 	while (eventidx ~= nil)
	 	do
	   	--self:CustomLevelDebug("Number of quotes in "..setidx.."-"..eventidx.." "..#self.db.profile.quotes[setidx][eventidx])
			number = number + #self.db.profile.quotes[setidx][eventidx]
	 		eventidx = next(self.db.profile.quotes[setidx], eventidx)
	 	end
	 end
	 setidx = next(self.db.profile.quotes, setidx)
  end
  setidx = next(self.db.profile.quotes["Class"], nil)
  while (setidx ~= nil)
  do
  	 eventidx = next(self.db.profile.quotes["Class"][setidx], nil)
	 while (eventidx ~= nil)
	 do
	  	--self:CustomLevelDebug("Number of quotes in Class "..setidx.."-"..eventidx.." "..#self.db.profile.quotes["Class"][setidx][eventidx])
		number = number + #self.db.profile.quotes["Class"][setidx][eventidx]
	 	eventidx = next(self.db.profile.quotes["Class"][setidx], eventidx)
	 end
	 setidx = next(self.db.profile.quotes["Class"], setidx)
  end
  eventidx = next(self.db.char.quotes, nil)
  while (eventidx ~= nil)
  do
	 --self:CustomLevelDebug("Number of quotes in "..eventidx.." "..#self.db.char.quotes[eventidx])
	 number = number + #self.db.char.quotes[eventidx]
	 eventidx = next(self.db.char.quotes, eventidx)
  end
  return number
end

function Loudmouth:Output_AFK(force)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:Output_AFK(",(force or ""),");");
  self:UnregisterEvent("CHAT_MSG_SYSTEM")
  if (self:Get_Event_State("AFK") == 1 or force == "FORCE") then
    self:Choose_Quote_Event("AFK",outputlist)
    SendChatMessage(currentquote["quote"],"Guild")
    if (GetNumRaidMembers() > 1) then
      SendChatMessage(currentquote["quote"],"Raid")
    elseif (GetNumPartyMembers() >= 1) then
      SendChatMessage(currentquote["quote"],"Party")
    end
    SendChatMessage(currentquote["quote"],"AFK")
  end
  self:RegisterEvent("CHAT_MSG_SYSTEM")
end

function Loudmouth:Output_Excuse(x,force)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:Output_Excuse(",x,(force or ""),");");
  --if x then
  	--self:Print("Output_Excuse("..x..")")
  --end
  if (self:Get_Event_State("Excuses") == 1 or force) then
    self:Choose_Quote_Event("Excuses",outputlist)
    self:Spew(x)
  end
end

function Loudmouth:Quote_Delete()
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:Quote_Delete(",");");
  local idx = self.editing_item
  local i

  if (self.edit_set_name == "Char") then
    table.remove(self.db.char.quotes[self.edit_event_name],self.editing_item)
  elseif (self.edit_set_name == "Class") then
    table.remove(self.db.profile.quotes["Class"][self.className][self.edit_event_name],self.editing_item)
  else
    table.remove(self.db.profile.quotes[self.edit_set_name][self.edit_event_name],self.editing_item)
  end
  self:GUI_Input_Disable()
   LMFrame_Quote_QuoteEdit:ClearFocus()
  self:Auto_Vars()
  self:Update_GUI_Data()
  self.current_total_quotes = self.current_total_quotes - 1
  self:GUI_ListBox_OnShow("LMFrame_Quote_QuoteList")
end

function Loudmouth:Quote_Add(quote, set, event)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:Quote_Add(",quote,",",set,",",event,");");
  local newindex
  if (set == "Char") then
    newindex = #self.db.char.quotes[event] + 1
    self.db.char.quotes[event][newindex] = {}
	 self.db.char.quotes[event][newindex]["quote"] = quote
	 self.db.char.quotes[event][newindex]["emote"] = LMEditFrame_Emote:GetChecked()
  elseif (set == "Class") then
    newindex = #self.db.profile.quotes["Class"][self.className][event] + 1
    self.db.profile.quotes["Class"][self.className][event][newindex] = {}
	 self.db.profile.quotes["Class"][self.className][event][newindex]["quote"] = quote
	 self.db.profile.quotes["Class"][self.className][event][newindex]["emote"] = LMEditFrame_Emote:GetChecked()
  else
    newindex = #self.db.profile.quotes[set][event] + 1
    self.db.profile.quotes[set][event][newindex] = {}
	 self.db.profile.quotes[set][event][newindex]["quote"] = quote
	 self.db.profile.quotes[set][event][newindex]["emote"] = LMEditFrame_Emote:GetChecked()
  end
  self:Auto_Vars()
  self:GUI_ListBox_OnShow("LMFrame_Quote_QuoteList")
  self:GUI_Input_Disable(1)
  eastereggunlock(quote)
  local _,max=LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar:GetMinMaxValues()
  LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar:SetValue(max)
  self.current_total_quotes = self.current_total_quotes + 1
  self:GUI_ListBox_OnScroll(LMFrame_Quote_QuoteList)
end

function Loudmouth:Quote_Edit()
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:Quote_Edit(",");");
  self:Auto_Vars()
  local quote = LMFrame_Quote_QuoteEdit:GetText()
  --local event = self.db.profile["_QuoteEvent"]
  --local event_name = self.UI.dropdowns["_QuoteEvent"].table[event]
  --local next_index = #self.db.profile.quotes[self.current_set_name][self.current_event_name]+1
  local last_seen = 0

  if (strlen(quote) == 0) then	
    --self:Print(L["Quote was blank. Skipping."])
  	 return
  end
  last_seen = self.editing_item
  if (self.editing_item == 0) then
    self:Quote_Add(quote,self.edit_set_name,self.edit_event_name)
	 return
  --end
  --if (self.editing_item > 0) then
  else
    self:Quote_Replace(quote,self.edit_set_name,self.edit_event_name)
	 return
  end

  if (self.editing_item > 0 and strlen(quote) > 0) then	
	if (not self.db.profile.quotes[self.edit_set_name][self.edit_event_name][self.editing_item]) then
		self.db.profile.quotes[self.edit_set_name][self.edit_event_name][self.editing_item] = {}
	end
  	self.db.profile.quotes[self.edit_set_name][self.edit_event_name][self.editing_item]["quote"] = quote
	self.db.profile.quotes[self.edit_set_name][self.edit_event_name][self.editing_item]["emote"] = LMEditFrame_Emote:GetChecked()
	self.editing_item = 0
  end

  self:GUI_ListBox_OnShow("LMFrame_Quote_QuoteList")
  self:GUI_Input_Disable()
   LMFrame_Quote_QuoteEdit:ClearFocus()
  self:Auto_Vars()
  if (scrolltobottom)
  then	local _,max=LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar:GetMinMaxValues()
  			LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar:SetValue(max)
  			self:GUI_ListBox_OnScroll()
  end
end

function Loudmouth:Quote_Has_Options(number)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:Quote_Has_Options(",number,");");
  local result = false

  --if (quotelist[number] and quotelist[number]["emote"] == 1) then
  if (editlist[number] and editlist[number]["emote"] == 1) then
    result = true
  end
  return result
end

function Loudmouth:Quote_Replace(quote, set, event)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:Quote_Has_Options(",number,");");
  if (set == "Char") then
	 self.db.char.quotes[event][self.editing_item]["quote"] = quote
	 self.db.char.quotes[event][self.editing_item]["emote"] = LMEditFrame_Emote:GetChecked()
	 if (self.db.char.quotes[event][self.editing_item]["IsModule"]) then
	 	self.db.char.quotes[event][self.editing_item]["IsModule"] = nil
	 end
  elseif (set == "Class") then
	 self.db.profile.quotes["Class"][set][event][self.editing_item]["quote"] = quote
	 self.db.profile.quotes["Class"][set][event][self.editing_item]["emote"] = LMEditFrame_Emote:GetChecked()
	 if (self.db.profile.quotes["Class"][set][event][self.editing_item]["IsModule"]) then
	 	self.db.profile.quotes["Class"][set][event][self.editing_item]["IsModule"] = nil
	 end
  else
	 self.db.profile.quotes[set][event][self.editing_item]["quote"] = quote
	 self.db.profile.quotes[set][event][self.editing_item]["emote"] = LMEditFrame_Emote:GetChecked()
	 if (self.db.profile.quotes[set][event][self.editing_item]["IsModule"]) then
	 	self.db.profile.quotes[set][event][self.editing_item]["IsModule"] = nil
	 end
  end
  self:Auto_Vars()
  self:GUI_ListBox_OnShow("LMFrame_Quote_QuoteList")
  self:GUI_Input_Disable(1)
  LMFrame_Quote_QuoteEdit:ClearFocus()
end

function Loudmouth:Reset_Quote_Vars(outtable)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:Reset_Quote_Vars(",outtable,");");
  local item = nil

  statement = ""
  currentquote["quote"] = ""
  currentquote["emote"] = 0

  for item = 1, #outtable
  do
    table.remove(outtable,item)
  end
end

function Loudmouth:Set_Event_State(event,value)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:Set_Event_State(",event,",",value,");");
  if value == nil then
    value = 0
  end
  self.db.profile.enabled[event] = value
end

function Loudmouth:Set_Rate(event, value)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:Set_Rate(",event,",",value,");");
  self.db.profile.rates[event] = value
end

function Loudmouth:Spew(ovr)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:Spew(",(ovr or ""),");");
  if (statement == '') then
    if currentquote["quote"] == '' then 
	   return 
    else
	   statement = currentquote["quote"]
	 end
  end

  local output = self.db.profile.Channel

  if ovr then
	if (ovr == "g" or ovr == "G" or ovr=="Guild") then output = "Guild" end
	if (ovr == "o" or ovr == "O" or ovr=="Officer") then output = "Officer" end
	if (ovr == "p" or ovr == "P" or ovr=="Party") then output = "Party" end
	if (ovr == "r" or ovr == "R" or ovr=="Raid") then output = "Raid" end
	if (ovr == "s" or ovr == "S" or ovr=="Say") then output = "Say" end
	if (ovr == "u" or ovr == "U" or ovr=="UI") then output = "UI" end
	if (ovr == "y" or ovr == "Y" or ovr=="Yell") then output = "Yell" end
  end
  
  local orig_output = output

  self.LastQuoted = GetTime()
  if (GetNumRaidMembers() == 0 and output == 'Raid') then output = 'Party'; end 
  if (GetNumPartyMembers() == 0 and output == 'Party') then output = 'Say'; end

  if (orig_output ~= output) 
  then self:CustomLevelDebug(1,0,1,0,Loudmouth.dataFrame,nil,"Downgrading from "..orig_output.." to "..output)
  end

  if (currentquote["emote"] == 1) then output = "EMOTE" end

  if (output == "UI") then
    self:Print(statement)
  elseif (type(output) == "number") then
    self:Print("Got a number!")
  else
    SendChatMessage(statement,output)
  end

  --
  -- The following line probably doesn't belong here, I just wanted to save 
  -- this default in a function I'm sure will be called eventually
  --
  if (self:IsDebugging() == true) then
    self.db.profile.Debug = 1
  else
    self.db.profile.Debug = 0
  end
end

function Loudmouth:Throttle()
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:Throttle(",");");
  if (self:IsDebugging()) then
    return false
  end

  --self:Print("Last Quote made "..(GetTime() - self.LastQuoted).." seconds ago")
  if ((GetTime() - self.LastQuoted) < self.db.profile.rates["Wisecrack"]) then	
    --self:Print("Throttling output, said something too recently.")
    Loudmouth:StartMetro("Loudmouth",floor(self.db.profile.rates["Wisecrack"]/0.9+2))
  	 return true
  end
  return false
end

function Loudmouth:UI_Dropdown_Select(dropdown,value)
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:UI_Dropdown_Select(",dropdown,",",value,");");
  local index
  local item = self.UI.dropdowns[dropdown]
	-- LMFrame_<item.frame><index>_Text:SetText(<item.table[<item.selected>]>)

  --self:Print("Updating "..dropdown.." to "..value)
  if (item) then
  		for index = 1, #item.table do
			if (item.table[index] == value) then
				item.selected = index
				getglobal("LMFrame_"..item.frame..item.index.."_Text"):SetText(item.table[item.selected])
			end
		end
  end
end

function Loudmouth:Update_GUI_Data()
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:Update_GUI_Data(",");");
  local i

  -- Set GUI UI Element Values
  self.db.profile.Debug = self:IsDebugging()
  for i=1, #self.GUI_Update do
   --self:Print("Executing code: "..self.GUI_Update[i])
	assert(loadstring(self.GUI_Update[i]))()
  end

  -- Update the Quotes tab's rates
  self:GUI_Rate_Show()
  self:GUI_ListBox_OnShow("LMFrame_Quote_QuoteList")
  -- Update the tooltip and other ACE objects
  self:Update()
end

function Loudmouth:Vasectomy()
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:Vasectomy(",");");
  local set,event,index,className,comment,value,setsize
  local debugtext = ""

	if (UnitSex("Player") == 2) then
		comment = L["Vasectomy"]
	elseif (UnitSex("Player") == 3) then
		comment = L["Mastectomy"]
	elseif (UnitSex("Player") == 1) then
		comment = L["Sterilization of... whatever you are"]
	end -- gender check
  for set,value in pairs(self.db.profile.quotes) do
  		if (set == "Class") then
			for className = 1,#self.db.profile.quotes["Class"] do
				for event = 1,#self.db.profile.quotes["Class"][className] do
					for index = 1,#self.db.profile.quotes["Class"][className][event] do
						if (strlen(self.db.profile.quotes["Class"][className][event][index]["quote"]) < 1) then
							self:CustomLevelDebug(1,1,1,0,Loudmouth.dataFrame,nil,L["Biopsy shows that quote # "]..index..L[" in Class set for "]..set..L[" for event "]..event..L[" is zero length. Initiating "]..comment)
							table.remove(self.db.profile.quotes["Class"][className][event],index)
							index = index - 1
						end -- strlen
					end -- index
				end -- event
			end -- className
		else
			setsize = 0;
			debugtext = ": inspecting "..set..": "
			for event,value in pairs(self.db.profile.quotes[set]) do
				debugtext = debugtext .. event.."("..#self.db.profile.quotes[set][event]..") "
				--self:Print(comment,": inspecting "..set..":"..event.."("..#self.db.profile.quotes[set][event]..")")
				setsize = setsize + #self.db.profile.quotes[set][event]
				for index = 1,#self.db.profile.quotes[set][event] do
					if (strlen(self.db.profile.quotes[set][event][index]["quote"]) < 1) then
						self:CustomLevelDebug(1,1,1,0,Loudmouth.dataFrame,nil,L["Biopsy shows that quote # "]..index..L[" in set "]..set..L[" for event "]..event..L[" is zero length. Initiating "]..comment)
						table.remove(self.db.profile.quotes[set][event],index)
						index = index - 1
					end	-- if truncating
  					eastereggunlock(self.db.profile.quotes[set][event][index]["quote"])
				end	-- for index
			end -- for event
  			Loudmouth:CustomLevelDebug(1,1,1,1,Loudmouth.dataFrame,nil,comment..debugtext)
			if (setsize == 0 and set ~= "Default" and set ~= "Class") then
				self:CustomLevelDebug(1,1,1,0,Loudmouth.dataFrame,nil,L["Biopsy shows that set "]..set..L[" is zero length. Initiating "]..comment)
				self.db.profile.quotes[set] = nil
			end
		end
  end
	for event,value in pairs(self.db.char.quotes) do
		for index = 1,#self.db.char.quotes[event] do
			if (strlen(self.db.char.quotes[event][index]["quote"]) < 1) then
				self:CustomLevelDebug(1,1,1,0,Loudmouth.dataFrame,nil,L["Biopsy shows that quote # "]..index..L[" in set Char for event "]..event..L[" is zero length. Initiating "]..comment)
				table.remove(self.db.char.quotes[event],index)
				index = index - 1
			end
		end
	end
end

function Loudmouth:FINGER()
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:FINGER(",");");
  if (self.LastFingered == nil) then 
  	self.LastFingered = 0 
  end
  if ((GetTime() - self.LastFingered) >= 60) then	
  		local output = "Raid"
		local orig_output = "Raid"

  		self.LastFingered = GetTime()
  		if (GetNumRaidMembers() == 0 and output == 'Raid') then output = 'Party'; end 
  		if (GetNumPartyMembers() == 0 and output == 'Party') then output = 'Guild'; end
		
  		if (orig_output ~= output) 
  		then self:CustomLevelDebug(1,0,1,0,Loudmouth.dataFrame,nil,"Downgrading from "..orig_output.." to "..output)
  		end
		
    	SendChatMessage("                /--/)",output)
    	SendChatMessage("              /   //",output)
    	SendChatMessage("            /    / /",output)
    	SendChatMessage("       /--/'   '/---`--",output)
    	SendChatMessage("    /'/   /    /       /--\\ ",output)
    	SendChatMessage("  ('(   -(  -       ~/'   ')",output)
    	SendChatMessage("   \\                 \\/    /",output)
    	SendChatMessage("    \\   \\           _ --",output)
    	SendChatMessage("     \\              (",output)
    	--SendChatMessage("      \\             \\ ",output)
    	SendChatMessage("STFU FTW!!!!!!!",output)
		local result = self:SendPrioritizedCommMessage("ALERT","GUILD","Fing",GetTime() - self.LastFingered)
		self:CustomLevelDebug(1,0,1,1,Loudmouth.dataFrame,nil,"A> GUILD: Fing "..GetTime() - (self.LastFingered or 0)..".")
		eastereggs["Finger"]["state"] = 1
  end
  Loudmouth:Update_GUI_Data()
  Loudmouth:StartMetro("Loudmouth",67)
end

function Loudmouth:SHORT_BUS()
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:SHORT_BUS(",");");
  if (self.LastBussed == nil) then 
  	self.LastBussed = 0 
  end
  if ((GetTime() - self.LastBussed) >= 60) then	
  		local output = "Raid"
		local orig_output = "Raid"

  		self.LastBussed = GetTime()
  		if (GetNumRaidMembers() == 0 and output == 'Raid') then output = 'Party'; end 
  		if (GetNumPartyMembers() == 0 and output == 'Party') then output = 'Guild'; end
		
  		if (orig_output ~= output) 
  		then self:CustomLevelDebug(1,0,1,0,Loudmouth.dataFrame,nil,"Downgrading from "..orig_output.." to "..output)
  		end
		
    	--SendChatMessage("          +    + +     + +      + +      + +",output)
    	SendChatMessage("          .------------------------------.",output)
    	SendChatMessage("          +----. .-----. .------. .------. +",output)
    	SendChatMessage("          +  O+ +    +  +  o + +   o + +",output)
    	SendChatMessage(" .------+----' `-----' `------' `------' +",output)
    	SendChatMessage(" + 42                                           +",output)
    	SendChatMessage(" +            S H O R T   B U S       +         ()",output)
    	SendChatMessage(" +                                                +     _( . )",output)
    	SendChatMessage(" +    -------                  --------      +    ( . . . )",output)
    	SendChatMessage(" `---+ /--\\ +-------------+ /--\\ +-----'== -_-_/",output)
    	SendChatMessage("         \\--/                        \\--/       ",output)
    	SendChatMessage("There's your bus. Don't miss it!!!!!!",output)
		local result = self:SendPrioritizedCommMessage("ALERT","GUILD","Bus",GetTime() - self.LastBussed)
		self:CustomLevelDebug(1,0,1,1,Loudmouth.dataFrame,nil,"A> GUILD: Bus "..GetTime() - (self.LastBussed or 0)..".")
		eastereggs["Bus"]["state"] = 1
  end
  Loudmouth:Update_GUI_Data()
  Loudmouth:StartMetro("Loudmouth",67)
end

--
-- All Event handlers are located below this comment
--

function Loudmouth:RegisterMyEvents()
  Loudmouth:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"Loudmouth:RegisterMyEvents(",");");
  self:CustomLevelDebug(1,0,1,1,Loudmouth.dataFrame,nil,"Registering Events now. Let's kick the tires and light the fires.")
  self:RegisterEvent("CHAT_MSG_COMBAT_SELF_HITS") -- arg1=msg
  self:RegisterEvent("CHAT_MSG_COMBAT_SELF_MISSES") -- arg1=msg
  self:RegisterEvent("CHAT_MSG_EMOTE") -- arg1=msg arg2=player
  self:RegisterEvent("CHAT_MSG_MONSTER_EMOTE") -- arg1=msg
  self:RegisterEvent("CHAT_MSG_SYSTEM")
  self:RegisterEvent("CHAT_MSG_TEXT_EMOTE") -- arg1=msg arg2=player
  --self:RegisterEvent("CHAT_MSG_BG_SYSTEM_ALLIANCE") -- arg1
  --self:RegisterEvent("CHAT_MSG_BG_SYSTEM_HORDE") -- arg1
  --self:RegisterEvent("CHAT_MSG_SKILL") -- arg1=msg
  self:RegisterEvent("PLAYER_LEVEL_UP") -- arg1=level arg2-9=vals
  self:RegisterEvent("PLAYER_LEAVING_WORLD")
  self:RegisterEvent("PLAYER_LOGOUT")
  self:RegisterEvent("PLAYER_QUITING")
  --self:RegisterEvent("PLAYER_PVP_KILLS_CHANGED")
  --self:RegisterEvent("PLAYER_TARGET_CHANGED")
    --local name,realm = UnitName("target")
  --self:RegisterEvent("SPELLCAST_CHANNEL_START") -- arg1=ms arg2=spell
  --self:RegisterEvent("SPELLCAST_CHANNEL_STOP")
  --self:RegisterEvent("SPELLCAST_START") --arg1=spell arg2=ms
  --self:RegisterEvent("SPELLCAST_STOP")
end

function Loudmouth:CHAT_MSG_COMBAT_SELF_HITS()
  --self:Print("CHAT_MSG_COMBAT_SELF_HITS("..arg1..")")
  if (self:Throttle()) then return; end
  local you1, you2 = string.find(arg1, L["You"]);
  local crit, crit2 = string.find(arg1, L["crit"]);

  self:Reset_Quote_Vars(outputlist)
  if (self.db.profile.enabled["Crits"] ~= 0) then
    if (you1 == 1 and you2 == 3 and crit) then
      if (self:BeatTheOdds(self.db.profile.rates["Crits"])) then
		  self:Choose_Quote_Event("Crits",outputlist)
      end
    end
  end
  self:Spew()
end

function Loudmouth:CHAT_MSG_COMBAT_SELF_MISSES()
  --self:Print("CHAT_MSG_COMBAT_SELF_MISSES("..arg1..")")
  if (self:Throttle()) then return; end
  local message = "Loudmouth: miss"
  local item

  self:Reset_Quote_Vars(outputlist)

  if (self.db.profile.enabled["Misses"] ~= 0) then
    if (self:BeatTheOdds(Loudmouth.db.profile.rates["Misses"])) then
	   self:Choose_Quote_Event("Misses",outputlist)
    end
  end
  self:Spew()
end

function Loudmouth:CHAT_MSG_EMOTE()
  --self:CustomLevelDebug(2,0,1,1,Loudmouth.dataFrame,nil,"CHAT_MSG_EMOTE: "..arg1.." "..arg2);
end

function Loudmouth:CHAT_MSG_MONSTER_EMOTE()
  --self:Print("CHAT_MSG_MONSTER_EMOTE("..arg1..")")
  if (self:Throttle()) then return; end
  local message = "Loudmouth: runaway "..arg2
  local you1, you2 = string.find(arg1, L["run"]);
  local fear, fear2 = string.find(arg1, L["fear"]);

  self:Reset_Quote_Vars(outputlist)
  if (you1 ~= nil and fear ~= nil and self.db.profile.enabled["Fears"] ~= 0) then
    if (self:BeatTheOdds(self.db.profile.rates["Fears"])) then
	   self:Choose_Quote_Event("Misses",outputlist)
    end
  end
  self:Spew()
end

function Loudmouth:CHAT_MSG_SYSTEM()
  if not string.find(arg1,L["You are now AFK"]) then return end
  self:CustomLevelDebug(2,0,1,1,Loudmouth.debugFrame,nil,"CHAT_MSG_SYSTEM(",arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9,")")
  Loudmouth:Output_AFK()
end

function Loudmouth:CHAT_MSG_TEXT_EMOTE()
  --self:CustomLevelDebug(2,0,1,1,Loudmouth.dataFrame,nil,"CHAT_MSG_TEXT_EMOTE: "..arg1.." "..arg2);
end

function Loudmouth:PLAYER_LEAVING_WORLD()
  self:Print("Goodbye World!")
end

function Loudmouth:PLAYER_LEVEL_UP()
  local level = arg1
  local message = "Ding! Level "..level

	self:Spew("g")
	self:Spew("r")
end

function Loudmouth:PLAYER_LOGOUT()
  self:Print("Logout... before saved vars...")
  local setName, eventName, index
  for setName,_ in pairs(self.db.profile.quotes) do
    if (setName ~= "Class") then
	 	for eventName,_ in pairs(self.db.profile.quotes[setName]) do
			for index = #self.db.profile.quotes[setName][eventName], 1, -1 do
				if (self.db.profile.quotes[setName][eventName][index]["IsModule"] == true) then
					table.remove(self.db.profile.quotes[setName][eventName],index)
				end
			end -- index
	 	end -- event
	 end
  end -- set
end

function Loudmouth:PLAYER_QUITING()
  self:Print("You're QUITTING!???")
end

--
-- Code Snippets and Comments I want to remember are here to the end. 
-- Probably nothing of real interest down here. :)
--

  --UIErrorsFrame:AddMessage(message,1.0,1.0,1.0,5.0)
  --self:CustomLevelDebug(message)
--LMF = CreateFrame("Frame",nil,UIParent)
--LMFt=LMF:CreateTexture(nil,"BACKGROUND")
--LMFt:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Background")
--LMFt:SetAllPoints(LMF)
--LMF.texture=LMFt
--shown = false

  --LMF:SetFrameStrata("BACKGROUND")
  --LMF:SetWidth(100)
  --LMF:SetHeight(100)
  --LMF:SetPoint("CENTER",0,0)
  --LMF:SetMovable(true)
  --if (shown == true) then
    --LMF:Hide()
    --shown = false
  --else
    --LMF:Show()
    --shown = true
  --end

-- UnitSex("Unit") -> 1 = unknown, 2 = male, 3 = female
--function SU_EditBox:SetText(whatCommand)
  --local editBox = SU_EditBox;
  -- send the slash command to the chat box
  --ChatEdit_SendText(editBox);
--end
-- vim: ts=3 ai nu
